#include "denise.h"
#include <pwd.h>

char user; //who talks
struct DeniseHandle* handle;

int HandleDeniseCmd(struct DeniseHandle* , char* );
char intext[DENISE_SYS_BUFSIZE];

void Print(char* buffer)
{
	if (user && !strcmp(buffer, intext)) {
		if (handle->cache.user) {
			char *id = handle->cache.user->identify;
			printf("%.*s: %s\n", strchr(id, '+')-id, id, buffer);
		} else
			printf("%s: %s\n", "user", buffer);
	} else
		printf("denise: %s\n",buffer);	
	user = 0;
}

void Report(char* buffer)
{
	printf("> %s\n",buffer);
}

int CloseApp(struct DeniseAppHandle* apphandle, int errcode)
{
	char *configdirfile=NULL;
	if (handle)
		asprintf(&configdirfile,"%s/%s",handle->Prefix,CONFIG_FILE);
		DeniseSave(handle,DENISE_CMD_SAVECONFIG,configdirfile);
		if(configdirfile) free(configdirfile);
		DeniseCloseTalk(handle);
	if (apphandle)
		UNN_FreeNode((struct Node*)apphandle);
	return OK;
}

struct DeniseAppHandle* InitApp(char * appname)
{
	int errcode=ERR_NOERR;
	struct DeniseAppHandle* apphandle;
	char *home_dir;
	char prefix[255];
	struct passwd *pw;
	char *denisedir=NULL;
	char *command=NULL;

	printf("%s\n\n", appname);

	if (!(home_dir = getenv("HOME")))
		if ((pw = getpwuid(getuid())))
			home_dir = pw->pw_dir;

	if (home_dir)
		home_dir = strdup(home_dir);
	printf("home dir: %s\n\n", home_dir);
	if(!home_dir) {
		fprintf(stderr,"Nie moge znalezc katalogu domowego.");
		return FAIL;
	}
	strcpy(prefix,home_dir);
	strcat(prefix,"/.denise/");
	SetPrefix(prefix);
	asprintf(&denisedir,"%s",prefix);
	if(!opendir(denisedir)) {
		asprintf(&command,"install --mode=755 -d  %s",denisedir);
		printf("%s\n",command);
		system(command);
		if(command) free(command);
		asprintf(&command,"cp -rv %s/facts %s/",DATA_DIR,denisedir);
		printf("%s\n",command);
		system(command);
		if(command) free(command);
		asprintf(&command,"cp -rv %s/languages %s/",DATA_DIR,denisedir);
		printf("%s\n",command);
		system(command);
		if(command) free(command);
		asprintf(&command,"cp -rv %s/logic %s/",DATA_DIR,denisedir);
		printf("%s\n",command);
		system(command);
		if(command) free(command);
		asprintf(&command,"cp -rv %s/logbook %s/",DATA_DIR,denisedir);
		printf("%s\n",command);
		system(command);
		if(command) free(command);
		asprintf(&command,"chmod -R 755 %s",denisedir);
		printf("%s\n",command);
		system(command);
		if(command) free(command);
		asprintf(&command,"chown -R $USER %s",denisedir);
		printf("%s\n",command);
		system(command);
		if(command) free(command);
	} else closedir(denisedir);
	free(denisedir);
	

	if ((apphandle=(struct DeniseAppHandle*)UNN_AllocNode(sizeof(struct DeniseAppHandle))))
	{
		if ((handle=DeniseOpenTalk(Print,Report)))
			return apphandle;
		CloseApp(apphandle,errcode);
	}

	return FAIL;
}

int HandleDeniseEvents(struct DeniseAppHandle* apphandle)
{
	int err;

	printf("ALL OK\n");
	while (strcmp(intext,"quit"))
	{
		printf("READY\n");
		fgets(intext, DENISE_SYS_BUFSIZE-1, stdin);
		intext[strlen(intext)-1] = '\0';

		if (intext[0]=='/') {
			if (HandleDeniseCmd(handle,intext+1)==-1)
				return DONE; // jesli zwraca -1, to komenda quit
		} else {
			user = 1;
			if ((err=DeniseTalk(handle,intext,NULL,DENISE_SYS_BUFSIZE-1))) 
			{
				printf("%s\n",DeniseError(handle,err));
			}
		}
	}
	return OK;
}
