#ifndef UNN_LOCALE_H
#define UNN_LOCALE_H

struct LocaleEntry
{
        struct MinNode node;
        ULONG LocaleID;
        char* LocaleText;
};

// ogolne
#define MSG_PROGNAME 10
#define MSG_WRITE_YOUR_NAME 11
#define MSG_AREXXPORT 20
#define MSG_NO_AREXXPORT 21
#define MSG_EXITING 30
#define MSG_AVAILABLE_COMMANDS 40
#define MSG_SYNTAX_ERROR_AT 50
#define MSG_PL_TABLE 60
// konfiguracja
#define MSG_LOADING_CONFIG 70
#define MSG_SAVING_CONFIG 80
#define MSG_STANDARD_CONFIGURATION 90
#define MSG_SELECTED_LANGUAGE 100
#define MSG_LANGUAGE_NOT_SELECTED 110
#define MSG_NOT_DEFINED 120
// operacje na plikach danych
#define MSG_ERROR_OPENING_FILE 130
#define MSG_FILE_VERSION_ERROR 131
#define MSG_FILE_NOT_FOUND 140
#define MSG_DATA_LOADED 150
#define MSG_DATA_LOADING_ERROR 160
#define MSG_DATA_SAVED 170
#define MSG_DATA_SAVING_ERROR 180
#define MSG_LINE_TOO_LONG 190
#define MSG_INCORRECT_LINE 200
// bazy danych
#define MSG_LOADING_DATA 210
#define MSG_LOADED 220
#define MSG_SAVING_DATA 230
#define MSG_ERASING_DATA 240
// dane jezykowe
#define MSG_LANGUAGE_DATA 250
#define MSG_SORTING_VOCABULARY 260
#define MSG_VOCABULARY_SORTED 270
#define MSG_WORDS_NUMBER 280
// bazy faktow
#define MSG_FACTS_DATA 290
#define MSG_LOADING_FACTS_DATABASE 300
#define MSG_PREPARING_DATABASE 310
#define MSG_DENISE_THEME_FOUNDED 320
#define MSG_DENISE_THEME_NOT_FOUND 330
#define MSG_TOO_MUCH_DENISE_THEMES 340
#define MSG_ERASING_FACTS_DATABASE 350
#define MSG_ERASING_FACTS_DATABASES 360
#define MSG_NEW_FACTS_DATABASE 370
// bazy znaczen
#define MSG_MEANINGS_DATA 375
// dane logiczne
#define MSG_LOGIC_DATA 380
#define MSG_INCORRECT_IDENTIFIER 390
// wnioskowanie
#define MSG_NO_CLAUSES 400
#define MSG_NUMBER_OF_CLAUSES_USED 410
#define MSG_STATE_NOT_FOUND 420
#define MSG_UNKNOWN_STATE 430
// prezentacja wnioskowania
#define MSG_NOT 440
#define MSG_AND 450
#define MSG_OR 460
#define MSG_IS_FACT 470
#define MSG_IS_HYPOTHESIS 480
#define MSG_IS_CONCLUSION 490
#define MSG_BECAUSE 500
#define MSG_EMPTY_CLAUSE 501
// fakty
#define MSG_THEME_FORWARDING_EXPECTED 510
#define MSG_NO_THEMES_FORWARDING 520
#define MSG_THEME_FORWARDING_FAILED 530
// ekstrakcja
#define MSG_WORD_DECLENSION_NOT_FOUND 540
#define MSG_PRONOUN_NOT_IDENTIFIED 550
// logbook
#define MSG_UNKNOWN_WORD 560
// zadawanie pytan
#define MSG_TOO_FEW_THEMES_FOR_QUESTION 570
#define MSG_PROBLEM_WITH_DECLENSION 580
// analiza slow
#define MSG_WORDS_NOT_FOUND 590
#define MSG_WORDS_ANALYSIS_TIME 600
// analiza zdan pojedynczych
#define MSG_CLAUSE_ANALYSIS 610
// bledny operator logiczny laczacy zdania
#define MSG_WRONG_LOGIC_OPERATOR 620
// proba zapamietania faktu wypowiedzi
#define MSG_ERROR_IN_FACT_REMEMBER 630
// gramatyczna analiza wypowiedzi
#define MSG_SENTENCE_ANALYSIS 640
#define MSG_SENTENCE_ANALYSIS_FAILED 650
#define MSG_SENTENCE_ANALYSIS_TIME 660
// komunikaty odmiany zdania
#define MSG_WRONG_DECLENSION_STRUCTURE 670
#define MSG_MISSING_DECLENSION_DATA 680
#define MSG_DECLENSION_TABLE_TOO_SMALL 690
#define MSG_DECLENSION_OUT_OF_DATA 700
#define MSG_DECLENSION_FAILED 710
// tryb identyfikacji
#define MSG_IDENTIFICATION_MODE 720
#define MSG_IDENTIFICATION_SENTENCE 730
#define MSG_NO_IDENTIFICATION_SENTENCE 740
// zdanie w formie symboli
#define MSG_LOGIC_CLAUSE 750
#define MSG_LOGIC_CLAUSE_FORM 760
// zdanie puste
#define MSG_EMPTY_SENTENCE 770
// odpowiedz na pytanie "dlaczego", jesli nie widac w nim sensu
#define MSG_QUESTION_ABOUT 780
// prosba o wyjasnienie
#define MSG_EXPLAIN_PLEASE 790
// jesli nie widac sensu w wypowiedzi uzytkownika
#define MSG_SENTENCE_WITH_NO_SENSE 800
// analiza wstepna
#define MSG_PRELIMINARY_ANALYSIS 810
// analiza gramatyczna
#define MSG_GRAMMAR_ANALYSIS 820
#define MSG_GRAMMAR_ANALYSIS_FAILED 830
#define MSG_CONJUNCTIONS_ANALYSIS 831
#define MSG_CONJUNCTIONS_ANALYSIS_FAILED 832
#define MSG_CONTRADICTORY_SENTENCE 833
#define MSG_ALWAYS_TRUE_SENTENCE 834
#define MSG_EMPTY_CLAUSE_TRUE 835
// analiza tematyczna
#define MSG_THEME_ANALYSIS 840
#define MSG_SUBJECT_NOT_IDENTIFIED 850
#define MSG_THEME_NOT_FOUND 860
#define MSG_THEME_IDENTIFIED 870
#define MSG_NEED_IDENTIFICATION 880
#define MSG_WHAT_THEME_QUESTION 890
// analiza konwersacyjna
#define MSG_INTERLOCUTORY_ANALYSIS 900
#define MSG_IT_IS_ME_DENISE 910
#define MSG_USE_OTHER_DESCRIPTION 920
#define MSG_TALK_IN_SECOND_PERSON 930
#define MSG_WRONG_DENISE_IDENTIFICATION 940
#define MSG_NOT_SUPERVISOR_MODE 950
#define MSG_HELLO_NEW_USER 960
#define MSG_BYE_USER 970
// analiza logiczna
#define MSG_LOGIC_ANALYSIS 980
#define MSG_WRONG_IDENTIFIER 990
#define MSG_UNKNOWN_SITUATION 1000
#define MSG_WRONG_OR_CONJUNCTION 1010
#define MSG_WRONG_ANSWER_PARAMETER 1020
#define MSG_ANSWER_ITS_TRUE 1030
#define MSG_ANSWER_ITS_FALSE 1040
#define MSG_ANSWER_ITS_UNKNOWN 1050
#define MSG_ANSWER_ITS_TRUE_BECAUSE 1060
#define MSG_ANSWER_ITS_FALSE_BECAUSE 1070
#define MSG_REMEMBER_NEW_FACT 1080
#define MSG_SUBJECT_STILL_UNKNOWN 1090
#define MSG_SUBJECT_NOW_IDENTIFIED 1100
#define MSG_IDENTIFICATION_PROBLEM 1110
// zadawanie pytania
#define MSG_WRONG_QUESTION_PARAMETER 1120
#define MSG_QUESTION_BUILDING_FAILED 1130
// typ wypowiedzi
#define MSG_SENTENCE_TYPE 1140
#define MSG_SENTENCE_ANNOUNCE 1150
#define MSG_SENTENCE_QUESTION 1160
// preferowana odpowiedz
#define MSG_PREFERED_ANSWER 1170
#define MSG_PREFERED_PROVE 1180
#define MSG_PREFERED_NO_PROVE 1190
// wyjasnianie
#define MSG_HELP_EXPLAIN 1200

#endif
