#ifndef UNN_SYSTEM_H
#define UNN_SYSTEM_H

	#include <stdio.h>
	#include <stdlib.h>
	#include <stdarg.h>
	#include <string.h>
	#include <time.h>
	#include <ctype.h>
	#include <errno.h>
	#include <math.h>


//#define DECLARE_HANDLE(name) struct name##__ { int unused; }; typedef struct name##__ *name
//#define DECLARE_HANDLE(name) typedef void* name

	#ifdef AMIGA
//		#include <dos.h> // gcc sie burzy, ze nie ma zgody z time.h
		#include <sys/dir.h>
		#include <exec/memory.h>
		#include <exec/lists.h>
		#include <exec/types.h>
		#include <dos/dostags.h>
		#include <proto/reqtools.h>
		#include <proto/graphics.h>
		#include <proto/intuition.h>
		#include <proto/dos.h>
		#include <proto/iffparse.h>
		#include <proto/exec.h>
		#include <proto/gadtools.h>
		#include <proto/reqtools.h>
		#include <proto/lowlevel.h>
		#include <libraries/reqtools.h>

		#define UNN_AllocMem AllocVec
		#define UNN_FreeMem FreeVec
		#define UNN_Memcpy memcpy
		#define UNN_Memset memset
		#define STDARGS __stdargs

//		#define UNN_WINDOW struct Window*
		#define UNN_Instance ULONG
		#define UNN_Menu HMENU
		#define UNN_LibHandle struct Library*
		#define UNN_OpenLibrary(a) OpenLibrary(a,0L)
		#define UNN_CloseLibrary(a) CloseLibrary(a)

	typedef unsigned int UINT;
	typedef unsigned int LPARAM;
	typedef unsigned short WPARAM;
//	typedef struct UNN_Gadget* UNN_GADGET;
//	typedef struct UNN_Window* UNN_WINDOW;
#define UNN_Window struct Window*

//	#define UNN_GADGET struct UNN_Gadget

//#define UINT ULONG
//#define LPARAM int
//#define WPARAM int

		#define __Platform__ "Amiga"

//		struct Window*	UNN_ProgWindow;
//		struct Gadget*	UNN_ListView,*UNN_StatListView;
//		struct List*	UNNPRIV_PrintList;
//		ULONG	UNN_ProgramQuit;
	#endif

	#ifdef WIN32
		#include <windows.h>
		#include <windowsx.h>
		#include <process.h>
		#include <direct.h>
		#include <commctrl.h>
//		#include "\resource.h"

		#define UNN_Gadget HWND
		#define UNN_Window HWND
		#define UNN_Instance HINSTANCE
		#define UNN_Menu HMENU
		#define UNN_LibHandle HMODULE
		#define UNN_OpenLibrary(a) LoadLibrary(a)
		#define UNN_CloseLibrary(a) FreeLibrary(a)


//		#define UBYTE unsigned char
//		#define ULONG unsigned long
//		#define STRPTR unsigned char*

//	typedef unsigned int ULONG;	// declared as int because of potential probs with 64 bit processors (alpha)
	typedef unsigned short UWORD;
//	typedef int LONG;
//	typedef short WORD;
	typedef unsigned char UBYTE;
//	typedef char BYTE;
	typedef unsigned char* STRPTR;

		#define UNN_AllocMem(x,y) calloc(x,1)
		#define UNN_FreeMem free
		#define UNN_Memcpy memcpy
		#define UNN_Memset memset

		#define STDARGS

		#define __Platform__ "Windows"
	#endif

#ifdef UNIX
	#define __Platform__ "Unix"
	#define __AMIGADATE__ __DATE__
	#include <memory.h>
	#include <unistd.h>
	#include <strings.h>
	#include <netdb.h>
#include <sched.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>

	typedef short BOOL;
	#define TRUE 1
	#define FALSE 0
	typedef unsigned int UINT;
	typedef unsigned int LPARAM;
	typedef unsigned short WPARAM;
	typedef unsigned int ULONG;	// declared as int because of potential probs with 64 bit processors (alpha)
	typedef unsigned short UWORD;
	typedef int LONG;
	typedef short WORD;
	typedef unsigned char UBYTE;
	typedef char BYTE;
	typedef unsigned char* STRPTR;

//		#define UBYTE unsigned char
//		#define ULONG unsigned long
		#define UNN_AllocMem(x,y) calloc(x,1)
		#define UNN_FreeMem free
		#define UNN_Memcpy memcpy
		#define UNN_Memset memset

	#define UNN_Gadget void*
	#define UNN_Window void*
//	typedef struct UNN_Gadget* UNN_GADGET;
//	typedef struct UNN_Window* UNN_WINDOW;
//		#define UNN_GADGET struct UNN_Gadget
//		#define UNN_WINDOW struct UNN_Window
		#define UNN_Instance char*	//HINSTANCE
		#define UNN_Menu char*	// HMENU

		#define _strnicoll strnicmp
		#define strnicmp strncasecmp
		#define stricmp strcasecmp

	#define CloseSocket close
#endif

#ifndef AMIGA
/*
 *  List Node Structure.  Each member in a list starts with a Node
 */

struct Node {
    struct  Node *ln_Succ;	/* Pointer to next (successor) */
    struct  Node *ln_Pred;	/* Pointer to previous (predecessor) */
    UBYTE   ln_Type;
    BYTE    ln_Pri;			/* Priority, for sorting */
    char    *ln_Name;		/* ID string, null terminated */
};	/* Note: word aligned */

/* minimal node -- no type checking possible */
struct MinNode {
    struct MinNode *mln_Succ;
    struct MinNode *mln_Pred;
};

/*
 *  Full featured list header.
 */
struct List {
   struct  Node *lh_Head;
   struct  Node *lh_Tail;
   struct  Node *lh_TailPred;
   UBYTE   lh_Type;
   UBYTE   l_pad;
};	/* word aligned */

/*
 * Minimal List Header - no type checking
 */
struct MinList {
   struct  MinNode *mlh_Head;
   struct  MinNode *mlh_Tail;
   struct  MinNode *mlh_TailPred;
};	/* longword aligned */

#endif



	#ifndef UNN_Version
		#define UNN_Version "1.0.0"
	#endif
	#ifndef UNN_Build
		#define UNN_Build "1"
	#endif

	#ifndef UNN_ProgramName
		#define UNN_ProgramName "Network DataBase Server"
	#endif
	#define UNN_Copyright "1998 Union Systems"
	#define About UNN_ProgramName UNN_Version UNN_Copyright " Build " UNN_Build __DATE__ __TIME__
	#define FAIL 	0
	#define OK 		1
	#define DONE	0
	#define INLINE // __inline __regargs

#define UNN_SYS_BUFSIZE 2048		// rozmiar bufora do roznych operacji

#define UNN_IsListEmpty(x) \
	( ((x)->lh_TailPred) == (struct Node *)(x) )

#define UNN_IsMinListEmpty(x) \
	( ((x)->mlh_TailPred) == (struct Node *)(x) )

//	extern struct UNN_Gadget* UNN_ListView;
//	extern UNN_GADGET* UNN_ListView;
//	extern char	UNN_errText[256];
//	extern char	UNN_WorkDir[256];
	#include "UNN_System_protos.h"
#endif

