// ***************************************************************************************
//                                           GLOBAL
// ***************************************************************************************

#include "denise.h"
#include "denise_protos.h"

// zabezpieczenie - ustawienia standardowe
#ifdef AMIGA
   char *pl_table=" abcdefghijklmnopqrstuvwxyz";
#endif
#ifdef UNIX
   char *pl_table=" abcdefghijklmnopqrstuvwxyz";
#endif
#ifdef PC_WIN
   char *pl_table=" abcdefghijklmnopqrstuvwxyz";
#endif

// deklaracje prywatne

// ***************************************************************************************
// EXTERN                    void glo_current_time(char *dest,int mode)
// ***************************************************************************************
void glo_current_time(char *dest,int mode)
{
   /*
   funkcja zwraca aktualny czas, oraz, jesli tryb mode=1, dodatkowo
   dwucyfrowa wartosc losowa, majaca znaczenie identyfikacyjne
   */
   time_t t=time(NULL);
   char temp1[30];

   dest[0]='\0';

	strftime(temp1,21,"%Y-%m-%d-%H-%M-%S",localtime(&t));
   if (mode==1) sprintf(dest,"%s-%.2ld",temp1,clock() % 100);
   else strcpy(dest,temp1);
}
// ***************************************************************************************
// EXTERN                          ULONG glo_file_lenght(FILE *)
// ***************************************************************************************
ULONG glo_file_lenght(FILE *stream)
{
	/*
	funkcja sprawdza dlugosc pliku,
	a nastepnie ustawia wskaznik na miejsce poczatkowe (jak przy wywolaniu funkcji)
	*/

   ULONG size;
   char temp[100];
//	fpos_t ptr;

//	if (fgetpos(stream,&ptr)!=0) return 0;
   if (fseek(stream,0,SEEK_END)!=0) return 0;
   size=ftell(stream);
	rewind(stream);
//	fsetpos(stream,&ptr);
	glo_fgets(temp,100,stream);
   return size;
}

// ***************************************************************************************
// EXTERN                       int glo_what_first(handle,char *,char *,int )
// ***************************************************************************************

int glo_what_first(struct DeniseHandle *handle,char *text1,char *text2,int max_len)
{
   /*
   funkcja zwraca, ktory z parametrow (text1,text2) alfabetycznie
   wystepuje pierwszy; parametr max_len okresla liczbe znakow,
   ktore beda skontrolowane, dla max_len<=0 wyrazy zostana
   sprawdzone na calej dlugosci
   funkcja zwraca 0 jesli kolejnosc jest dowolna (wyrazy identyczne na podanej dlugosci)
   */

   char *zm1,*zm2,keymap[200];
   int nr1,len,len1,len2;

   len1=strlen(text1);
   len2=strlen(text2);
   len=min(len1,len2);
   if (max_len>0 && max_len<len) len=max_len;
   else max_len=max(len1,len2);

	sprintf(keymap,"%s",UNN_GetLocaleString(handle,MSG_PL_TABLE,pl_table));
//DeniseReport(handle,"keymap: %s",keymap);

   for (nr1=0;nr1<len;nr1++)
   {
	  if(text1[nr1]==text2[nr1]) continue;
	  zm1=strchr(keymap,text1[nr1]);
	  zm2=strchr(keymap,text2[nr1]);

	  if (zm1<zm2) return 1;
	  else if (zm1>zm2) return 2;
   }
   if (strncmp(text1,text2,max_len)==0) return 0;
   return (min(len1,max_len)>min(len2,max_len) ? 2 : 1);
}

// ***************************************************************************************
// EXTERN                         int glo_count_parts(handle, char *,char )
// ***************************************************************************************

int glo_count_parts(struct DeniseHandle *handle,char *ciag,char separator)
{
   /*
   funkcja zwraca liczbe czesci, na ktore mozna podzielic podany ciag
   przy uzyciu podanego znaku separatora
   */
//	FILE *stream;
	int flip,ile_czesci;
   char *ptr;

   // przystosowanie do dwoch rodzajow parametrow: "" i NULL
   if (ciag) if (strlen(ciag)==0) ciag=NULL;

   // kontrola czy podano ciag
   if (ciag==NULL)
   {
	  DeniseReport(handle,"blad: (count_parts) funkcje wywolano z blednymi parametrami: '%s' (separator: '%c')",ciag,separator);
//stream=fopen("out.txt","w");
//	 fprintf(stream,"blad: (count_parts) funkcje wywolano z blednymi parametrami: '%s' (separator: '%c')\n",ciag,separator);
//fclose(stream);
	  return 0;
   }
	ptr=ciag;
	ile_czesci=1;
	flip=0;
	while(*ptr) {
		if(flip) {
			if(*ptr==')') flip--;
			if(*ptr=='(') flip++;
			goto next;
			}
		if(*ptr=='(') flip++;
			else if(*ptr==separator) ile_czesci++;
next:	ptr++;}
   return ile_czesci;
}

// ***************************************************************************************
// EXTERN                      int glo_get_part(char* ,int ,char* ,char)
// ***************************************************************************************

int glo_get_part(char *ciag,int part_nr,char *wynik,char separator)
{
   /*
   funkcja podstawia do wyniku czesc part_nr z podanego ciagu,
   przy zalozeniu, ze do separacji czesci uzywa sie podanego
   znaku separatora,
   */

   char *ptr;
   int nr1,ile_czesci,flip;

   // przystosowanie do dwoch rodzajow parametrow: "" i NULL
   if (ciag) if (strlen(ciag)==0) ciag=NULL;
   // kontrola czy podano ciag
   if (ciag==NULL || wynik==NULL || part_nr<1)
   {
	  printf("blad: (get_part) funkcje wywolano z blednymi parametrami (ciag: %s)\n",ciag);
	  return 0;
   }
   // wyzerowanie wyniku
   wynik[0]='\0';
	ptr=ciag;
	ile_czesci=1;
	flip=0;
	while(*ptr)
		{
		if(ile_czesci==part_nr) break;
		if(flip) {
			if(*ptr==')') flip--;
			if(*ptr=='(') flip++;
			goto next;
			}
		if(*ptr=='(') flip++;
			else if(*ptr==separator) ile_czesci++;
next:		ptr++;}
	if(ile_czesci!=part_nr) {
		 printf("blad: (get_part) podany ciag: '%s' nie ma tylu (%d) czesci lub nie ma w nim separatora \"%c\"\n",ciag,part_nr,separator);
		 return 0;
		}
	nr1=0;
	flip=0;
	while(*ptr)
		{
		if(flip) {
			if(*ptr==')') flip--;
			if(*ptr=='(') flip++;
			goto next1;
			}
		if(*ptr=='(') flip++;
		else if(*ptr==separator) break;
next1:		wynik[nr1]=*ptr;
		nr1++;
		ptr++;}
	wynik[nr1]='\0';
   return 1;
}

// ***************************************************************************************
// EXTERN                   int glo_get_part_position(int ,char* ,char* ,char)
// ***************************************************************************************

int glo_get_part_position(int start,char *ciag,char *text,char separator)
{
   /*
   funkcja zwraca pozycje elementu (podanego w parametrze text) w podanym ciagu,
   przy zalozeniu, ze separatorem jest podany znak,
   pomijane sa przy tym czesci o numerach ponizej podanego w parametrze start
   */

   int nr1,ile_part,flip;
   char *temp,*ptr;

   // przystosowanie do dwoch rodzajow parametrow: "" i NULL
   if (ciag) if (strlen(ciag)==0) ciag=NULL;
   if (text) if (strlen(text)==0) text=NULL;

   // kontrola czy podano ciag
   if (ciag==NULL || text==NULL || start<1) return 0;
   temp=malloc(strlen(ciag)+1);
   if(temp==NULL) return 0;
	nr1=0;
	*temp='\0';
	ptr=ciag;
	ile_part=1;
	flip=0;
	while(*ptr) {
		if(flip) {
			if(*ptr==')') flip--;
			if(*ptr=='(') flip++;
			goto next;
			}
		if(*ptr=='(') flip++;
		else
		if(*ptr==separator) {
			temp[nr1]='\0';
			if(ile_part>=start)
				{if(strcmp(temp,text)==0) {free(temp);
										  return(ile_part);}
				}
			nr1=0;
			ptr++;
			ile_part++;
			continue;
			}
next:	temp[nr1]=*ptr;
		nr1++;
		ptr++;
		}
	temp[nr1]='\0';
	if(ile_part>=start)
		{if(strcmp(temp,text)==0) {free(temp);
								  return(ile_part);}
		}
   free(temp);
   return 0;
}

// ***************************************************************************************
// EXTERN                    int glo_delete_part(handle,char* ,int ,char )
// ***************************************************************************************

int glo_delete_part(struct DeniseHandle *handle,char *ciag,int part_nr,char separator)
{
   /*
   funkcja kasuje z ciagu czesc o numerze podanym w parametrze part_nr,
   przy zalozeniu, ze do separacji czesci uzywa sie podanego znaku separatora,
   */

   char znak[2];
   char *wynik,*temp;
   int nr1,ile_part;

   // przystosowanie do dwoch rodzajow parametrow: "" i NULL
   if (ciag) if (strlen(ciag)==0) ciag=NULL;

   // kontrola czy podano ciag
   if (ciag==NULL || part_nr<1)
   {
	  printf("blad: (delete_part) funkcje wywolano z blednymi parametrami\n");
	  return 0;
   }

   // szukamy podanej czesci (text)
   ile_part=glo_count_parts(handle,ciag,separator);
   if (part_nr>ile_part) return 0;

   wynik=malloc(strlen(ciag)+1);
   temp=malloc(strlen(ciag)+1);
   wynik[0]='\0';

   sprintf(znak,"%c",separator);

   for (nr1=1;nr1<=ile_part;nr1++)
   {
	  if (glo_get_part(ciag,nr1,temp,separator)==0)
	  {
		 free(temp);
		 free(wynik);
		 return 0;
	  }
	  if (nr1!=part_nr) strcat(wynik,temp); 
		 strcat(wynik,znak);   
   }
   nr1=strlen(wynik);
   if(nr1>0) wynik[nr1-1]='\0';
   strcpy(ciag,wynik);

   free(temp);
   free(wynik);

   return 1;
}

// ***************************************************************************************
// EXTERN                    int glo_delete_part_sep(handle,char* ,int ,char )
// ***************************************************************************************

int glo_delete_part_sep(struct DeniseHandle *handle,char *ciag,int part_nr,char separator)
{
   /*
   funkcja kasuje z ciagu czesc o numerze podanym w parametrze part_nr,
   przy zalozeniu, ze do separacji czesci uzywa sie podanego znaku separatora,
   */

   char znak[2];
   char *wynik,*temp;
   int nr1,ile_part;

   // przystosowanie do dwoch rodzajow parametrow: "" i NULL
   if (ciag) if (strlen(ciag)==0) ciag=NULL;

   // kontrola czy podano ciag
   if (ciag==NULL || part_nr<1)
   {
	  printf("blad: (delete_part) funkcje wywolano z blednymi parametrami\n");
	  return 0;
   }

   // szukamy podanej czesci (text)
   ile_part=glo_count_parts(handle,ciag,separator);
   if (part_nr>ile_part) return 0;

   wynik=malloc(strlen(ciag)+1);
   temp=malloc(strlen(ciag)+1);
   wynik[0]='\0';

   sprintf(znak,"%c",separator);

   for (nr1=1;nr1<=ile_part;nr1++)
   {
	  if (glo_get_part(ciag,nr1,temp,separator)==0)
	  {
		 free(temp);
		 free(wynik);
		 return 0;
	  }
	  if (nr1!=part_nr) {strcat(wynik,temp);     //tu zaszla zmiana
					  strcat(wynik,znak);}       //tu zaszla zmiana
   }
   nr1=strlen(wynik);
   if(nr1>0) wynik[nr1-1]='\0';
   strcpy(ciag,wynik);

   free(temp);
   free(wynik);

   return 1;
}

// ***************************************************************************************
// EXTERN                            void glo_delay(int )
// ***************************************************************************************

void glo_delay(int ms)
{
	clock_t old=clock();
	for(;;)
	{
		if (clock()>CLK_TCK*ms/1000+old) break;
	}
}

// ***************************************************************************************
// EXTERN                       char *glo_fgets(char *,int,FILE *)
// ***************************************************************************************

char *glo_fgets(char *dst,int len,FILE *stream)
{
	/*
	funkcja wczytuje dane korzystajc z funkcji fgets(), przy czym realizuje
	take formatowanie:
	- eliminuje podwjne znaki zakoczenia linii,
//	- dokonuje konwersji znakw,
	*/

	char *result;
	int nr1;

	result=fgets(dst,len,stream);
	nr1=strlen(dst);
	if (nr1>=2)
	{
		if (dst[nr1-2]==13)
		{
			dst[nr1-2]=dst[nr1-1];
			dst[nr1-1]=dst[nr1];
		}
	}

	return result;
}
