// ***************************************************************************************
//                                          Grammar
// ***************************************************************************************

#include "denise.h"
#include "denise_protos.h"

#define ILE_FUNKCJI 5
#define WSPOLRZEDNE 0
#define PODRZEDNE 1
#define NADRZEDNE 2

// deklaracje prywatne

static struct Fact *find_fact(struct Fact *lista,struct Fact *fact);
static int universal_bell(char *member,int *ile,int ile_max);
static int check_stream(int *stream,int ile,int grupa);
static struct Fact* fact_remember(struct DeniseHandle* handle);
static void fact_free(struct Fact *fact);
static void check_pos_neg(struct DeniseHandle* handle);
static int check_opis_dane(struct DeniseHandle *handle,char *opis,char *dane);
static int gra_word_check(struct DeniseHandle* handle,struct Odmiany *odm1,struct Odmiany *odm2);
static int create_zrosty(struct DeniseHandle* handle);
static int check_zrosty(struct WordData *jedn,int ile);
static int zdania_pojedyncze(struct DeniseHandle* handle);
static int struktura_zdan(struct DeniseHandle* handle);
static int aktywne_rozbiory(struct DeniseHandle* handle);
static int droga(struct DeniseHandle* handle,int nr1);
static int droga_funkcyjna(struct DeniseHandle* handle);
static int struktura_grup(struct DeniseHandle* handle);
static int funkcje_grup(struct DeniseHandle* handle);
static int priorytet_zrostu(struct DeniseHandle* handle);
static int create_fleksyjne(struct DeniseHandle* handle);
static int new_fleksja_fleksyjnych(struct DeniseHandle* handle);
static int create_modyfleks(struct DeniseHandle* handle);
static int fleksja_modyfikatora(struct DeniseHandle* handle);
static void print_grupa(struct DeniseHandle *handle,struct Clause *clause,char *txt,int nr_grupy);
static void rysuj_strukture(struct DeniseHandle* handle,struct Clause *clause,int margines,int nr_grupy);
static void pokaz_rozbior_zdania(struct DeniseHandle* handle,struct Clause *clause);
static void print_grupa_zaakceptowana(struct DeniseHandle *handle,struct AcceptedClause *clause,char *txt,int nr_grupy);
static void rysuj_strukture_zaakceptowana(struct DeniseHandle* handle,struct AcceptedClause *clause,int margines,int nr_grupy);
static void pokaz_rozbior_zaakceptowany(struct DeniseHandle* handle,struct AcceptedClause *clause);
static int gra_zdania_pojedyncze(struct DeniseHandle* handle);
static int gra_funkcje_wyrazen(struct DeniseHandle* handle);
static int get_fleksyjny_group(struct DeniseHandle* handle,int fleks_nr);
static void sklejanie_wyrazow(struct DeniseHandle* handle,char *numery,char *posneg,struct GrammarExtData *wzory[100],char (*wyrazy)[100],int ile_wyr,char *sklejone,int nr_grupy);
static int gra_budowa_wyrazenia(struct DeniseHandle* handle);
static int gra_wymagana_czesc_mowy(struct DeniseHandle* handle,char *dane,int grupa);
static int gra_zabroniona_czesc_mowy(struct DeniseHandle* handle,char *dane,int grupa);
static int gra_zabronione_funkcje_miedzy(struct DeniseHandle* handle,char *dane,int grupa1,int grupa2);
static int gra_zabronione_fleksje_miedzy(struct DeniseHandle* handle,char *dane,int grupa1,int grupa2);
static int gra_struktura(struct DeniseHandle* handle);
static void gra_ocen_zdanie(struct DeniseHandle* handle);

static int w1,w2,w3,w4,w5,w6,w7,w8,w9; // zmienne kontrolujace koniec petli for
static int akt_zd; // aktualnie przetwarzane zdanie (struktura wewnetrzna)
static int ilewyr1=-1;         // globalna zamiast static wewnatrz funkcji

// ***************************************************************************************
// EXTERN                      BOOL grammar_analysis(struct DeniseHandle* )
// ***************************************************************************************
struct Fact *grammar_analysis(struct DeniseHandle* handle)
{
	// tymczasowe przechowywanie danych (do pronoun_analysis)
   struct Fleksja *voc_temp_fleks[100][100];
   struct Odmiany *voc_temp_odm[100][100];
   int voc_temp_poz[100][100];
	// pozostale zmienne
   unsigned long ile1=0,ile2=0,ile3=0,ile4=0,ile5=0,ile6=0,ile7=0,ile8=0,ile9=0,ile10=0;
   int nr1,nr2,nr3; //,poz;
   int quality=-1; // jakosc calej wypowiedzi
   int quality_temp1,ctrl_numb_temp1;
   int quality_temp2,ctrl_numb_temp2;
   long czas=clock();
   int byla_ocena,extraction_try,ile_accepted;
   char maska[100],temp_busy[200]; //dane[100]
   struct Fact *fact=NULL,*fact_last=NULL,*fact_new; // lista faktow - mozliwych rozbiorow zdania

   for(nr1=0;nr1<100;nr1++) maska[nr1]=nr1+1;

   // ******************************************************************** wyzerowanie parametrow
	extraction_try=0;
	strcpy(temp_busy,handle->syntax.busy);

	BEGIN_ANALYSIS:;
//DeniseReport(handle,"******** NEW ANALYSIS **********");
   handle->syntax.buffer_len=0;
   handle->syntax.words_number=glo_count_parts(handle,handle->syntax.busy,' ');

   for (nr1=0;nr1<handle->syntax.words_number;nr1++)
      glo_get_part(handle->syntax.busy,nr1+1,handle->syntax.words[nr1].orig,' ');

   // *********************************************** ustalanie zrostow w wyrazach odseparowanych
   if (handle->syntaxparams.prefix_check==1)
   {
      // zebranie danych o zrostach wszystkich wyrazow calej wypowiedzi
      if (create_zrosty(handle)==0)
      {
			DeniseMessage(handle,UNN_GetLocaleString(handle,MSG_WORDS_NOT_FOUND,"nie odnaleziono wyrazu lub wyrazow w bazie fleksji"));
         return NULL;
      }
		if (handle->viewparams.words==ON) DeniseReport(handle,UNN_GetLocaleString(handle,MSG_WORDS_ANALYSIS_TIME,"czas analizy zrostow: %ds"),(clock()-czas)/CLK_TCK);
   }
   // jesli wylaczono kontrole zrostow, to wszystkie wyrazy traktujemy jako jednolite
   else
   {
      for (nr1=0;nr1<handle->syntax.words_number;nr1++)
      {
         handle->syntax.words[nr1].zrost_nr=0;
         handle->syntax.words[nr1].ile_mozliwosci=1;
         handle->syntax.words[nr1].zrost_poz[0]=strlen(handle->syntax.words[nr1].orig);
      }
   }


//	BEGIN_ANALYSIS:;

//return NULL;

   do
   {
		if (handle->viewparams.words==ON)
		{
	      for (nr1=0;nr1<handle->syntax.words_number;nr1++)
	   	      DeniseReport(handle,"%s -> '%.*s' + '%s'",handle->syntax.words[nr1].orig,handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].zrost_nr],handle->syntax.words[nr1].orig,handle->syntax.words[nr1].orig+handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].zrost_nr]);
		}

      // *********************************************************** ustalanie priorytetu zrostow
      // wstepnie ustalamy pierwszy zrost wszystkich wyrazow jako glowny
      for (nr1=0;nr1<handle->syntax.words_number;nr1++)
         handle->syntax.words[nr1].priority=0;
//continue;
      do
      {
//         for (nr1=0;nr1<handle->syntax.words_number;nr1++)
//            DeniseReport(handle,"%d (%d),",handle->syntax.words[nr1].priority,handle->syntax.words[nr1].ile_mozliwosci);

         // *************************************************************** fleksja modyfikatorow
         // zbieramy wszystkie dane o fleksji wyrazow fleksyjnych
         if (create_modyfleks(handle)==0) goto PRIORYTET_ZROSTU_NEXT;
         ile1++;

         do
         {
            // ***************************************************** podzial na zdania pojedyncze
            handle->syntax.clause_number=handle->syntax.words_number;
            for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
            {
               handle->syntax.podzial[nr1].words_number=1;
               handle->syntax.podzial[nr1].wyrazy[0]=&handle->syntax.words[nr1];
            }

            do
            {
               /*
               - kopiujemy informacje o przydzieleniu wyrazow do zdan z tablic podrecznych w funkcji podzialu,
               - uwzgledniamy wszelkie modyfikacje gramatyczne, z modulu ekstrakcji itp.,
               - analizujemy powstale zdania w sposob opracowany,
               */
               for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
               {
                  handle->syntax.clause[nr1].words_number=handle->syntax.podzial[nr1].words_number;
                  for (nr2=0;nr2<handle->syntax.clause[nr1].words_number;nr2++)
                     handle->syntax.clause[nr1].wyrazy[nr2]=handle->syntax.podzial[nr1].wyrazy[nr2];
               }

/*					// EXTRACTION START
					extraction_try=0;
					ZDANIA_POJEDYNCZE_WITH_EXT:
*/
               // KATALIZATOR: MAX. LICZBA ZDAN POJEDYNCZYCH
               if (handle->syntax.clause_number>handle->syntaxparams.max_clauses && handle->syntaxparams.max_clauses>0) goto ZDANIA_POJEDYNCZE_NEXT;
               // KATALIZATOR KONIEC

               for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
               {
                  // KATALIZATOR: MIN. LICZBA WYRAZOW W ZDANIU
                  if (handle->syntax.clause[nr1].words_number<handle->syntaxparams.min_words) goto ZDANIA_POJEDYNCZE_NEXT;
                  // KATALIZATOR KONIEC

                  // praktycznie wystarczy do handle->syntax.clause_number-1
                  handle->syntax.clause_tree[nr1]=NADRZEDNE;
               }

               ile2++;
               do // ************************************************ struktura zdan pojedynczych
               {
                  // OCENA GRAMATYCZNA: STRUKTURA I PODZIAL NA ZDANIA POJEDYNCZE
                  if (gra_zdania_pojedyncze(handle)==0) goto STRUKTURA_ZDAN_NEXT;
                  // OCENA GRAMATYCZNA KONIEC
                  ile3++;

#ifdef PRINT
                  for (nr1=0;nr1<handle->syntax.clause_number-1;nr1++)
                  {
                     if (handle->syntax.clause_tree[nr1]==NADRZEDNE) printf("+ ");
                     if (handle->syntax.clause_tree[nr1]==WSPOLRZEDNE) printf("= ");
                     if (handle->syntax.clause_tree[nr1]==PODRZEDNE) printf("- ");
                  }
                  printf("\n");
#endif

//                  printf("******************* nowy uklad zdan\n");
						for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
							handle->syntax.ile_accepted[nr1]=0;

                  for (akt_zd=0;akt_zd<handle->syntax.clause_number;akt_zd++)
                  {
							ile_accepted=handle->syntax.ile_accepted[akt_zd];

                     handle->syntax.accepted[akt_zd][ile_accepted].quality=-1;
                     handle->syntax.clause[akt_zd].quality=0;
                     handle->syntax.clause[akt_zd].ctrl_numbers=0; // liczba miejsc oceny

                     byla_ocena=0;

//                     printf("ZDANIE %d\n",akt_zd);

                     // ************************************* tworzenie grup-wyrazow calosciowych
                     // wstepnie tworzymy tyle grup ile jest wyrazow
                     handle->syntax.clause[akt_zd].groups_number=handle->syntax.clause[akt_zd].words_number;
                     memcpy(handle->syntax.clause[akt_zd].member,maska,handle->syntax.clause[akt_zd].words_number);
                     ile4++;
                     do
                     {
                        w5=handle->syntax.clause[akt_zd].groups_number;
                        w6=handle->syntax.clause[akt_zd].words_number;

//DeniseReport(handle,"********************");
//for (nr1=0;nr1<w6;nr1++)
//DeniseReport(handle,"wyraz nr %d do grupy %d (wyrazow: %d, grup: %d)",nr1+1,handle->syntax.clause[akt_zd].member[nr1],w6,w5);

                        // KATALIZATOR: MIN. LICZBA GRUP W ZDANIU/MAX. LICZBA GRUP W ZDANIU
                        if (w5<handle->syntaxparams.min_groups || (w5>handle->syntaxparams.max_groups && handle->syntaxparams.max_groups>0)) goto PODZIAL_GRUP_NEXT;

                        // KATALIZATOR: MAX. LICZBA WYRAZOW W GRUPIE
                        if (w6>handle->syntaxparams.max_words && handle->syntaxparams.max_words>0)
                           for (nr1=0;nr1<w5;nr1++)
                              for (nr2=0,nr3=0;nr2<w6;nr2++)
                                 if (handle->syntax.clause[akt_zd].member[nr2]==nr1+1)
                                 {
                                    if (nr3==handle->syntaxparams.max_words) goto PODZIAL_GRUP_NEXT;
                                    nr3++;
                                 }
                        // KATALIZATOR KONIEC

                        // **************************** tworzenie wyrazow fleksyjnych (w grupach)
                        // wstepnie tworzymy tyle wyrazow fleksyjnych ile jest wyrazow odseparowanych w zdaniu
                        handle->syntax.clause[akt_zd].ile_fleks=handle->syntax.clause[akt_zd].words_number;
                        memcpy(handle->syntax.clause[akt_zd].fleksyjny,maska,handle->syntax.clause[akt_zd].words_number);

                        ile5++;
                        do
                        {
                           // KATALIZATOR: MIN. LICZBA WYRAZOW FLEKSYJNYCH
                           // moze byc min. tyle wyrazow fleksyjnych ile grup
                           if (handle->syntax.clause[akt_zd].ile_fleks<handle->syntax.clause[akt_zd].groups_number) goto WYRAZY_FLEKSYJNE_NEXT;
                           // KATALIZATOR KONIEC

                           // KATALIZATOR: WYRAZ FLEKSYJNY MUSI W CALOSCI BYC W JEDNEJ GRUPIE
                           // wyrazy odseparowane nalezace do jednego wyrazu fleksyjnego musza nalezec do jednej grupy
                           for (nr1=0;nr1<handle->syntax.clause[akt_zd].ile_fleks;nr1++)
                              for (nr2=0,nr3=0;nr2<handle->syntax.clause[akt_zd].words_number;nr2++)
                                 if (handle->syntax.clause[akt_zd].fleksyjny[nr2]==nr1+1)
                                 {
                                    if (nr3==0) nr3=handle->syntax.clause[akt_zd].member[nr2];
                                    else if (nr3!=handle->syntax.clause[akt_zd].member[nr2]) goto WYRAZY_FLEKSYJNE_NEXT;
                                 }
                           // KATALIZATOR KONIEC

                           // KATALIZATOR: MAX. LICZBA WYRAZOW ODSEPAROWANYCH W WYRAZIE FLEKSYJNYM
                           if (handle->syntax.clause[akt_zd].words_number>handle->syntaxparams.max_fleks && handle->syntaxparams.max_fleks>0)
                              for (nr1=0;nr1<handle->syntax.clause[akt_zd].ile_fleks;nr1++)
                                 for (nr2=0,nr3=0;nr2<handle->syntax.clause[akt_zd].words_number;nr2++)
                                    if (handle->syntax.clause[akt_zd].fleksyjny[nr2]==nr1+1)
                                    {
                                       if (nr3==handle->syntaxparams.max_fleks) goto WYRAZY_FLEKSYJNE_NEXT;
                                       nr3++;
                                    }
                           // KATALIZATOR KONIEC

                           // *************************************** fleksja wyrazow fleksyjnych
                           // zbieramy wszystkie dane o fleksji wyrazow fleksyjnych
//         handle->syntax.buffer_len=0;
                           if (create_fleksyjne(handle)==0) goto WYRAZY_FLEKSYJNE_NEXT;

									// identyfikujemy zaimki rzeczowne osobowe i dzierzawcze
//									if (ext_pronoun_analysis(handle)==FALSE) goto WYRAZY_FLEKSYJNE_NEXT;

                           ile6++;
                           do
                           {
                              // okreslenie czy grupa jest twierdzaca czy przeczaca
                              check_pos_neg(handle);

                              // OCENA GRAMATYCZNA: BUDOWA WYRAZENIA (GRUPY)
                              handle->syntax.clause[akt_zd].quality=0;
                              handle->syntax.clause[akt_zd].ctrl_numbers=0;
                              if (gra_budowa_wyrazenia(handle)==0) goto FLEKSJA_FLEKSYJNYCH_NEXT;
//DeniseReport(handle,"spox spox spox");
                              quality_temp1=handle->syntax.clause[akt_zd].quality;
                              ctrl_numb_temp1=handle->syntax.clause[akt_zd].ctrl_numbers;
                              // OCENA GRAMATYCZNA KONIEC

                              // ****************************** funkcje grup w zdaniu pojedynczym
                              // wstepnie ustalamy funkcje 1 grupy na 1 (PODMIOT),
                              // a funkcje drugiej drupy na 2,
                              // pozostale grupy na funkcje numer 3,
										for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
                              	handle->syntax.clause[akt_zd].function[nr1]=1;

										// zapamietanie danych fleksyjnych (beda modyfikowane przy "pronoun_analysis")
										for (nr1=0;nr1<handle->syntax.buffer_len;nr1++)
										for (nr2=0;nr2<handle->syntax.voc_buffer[nr1].fleks_ile;nr2++)
										{
                              	voc_temp_fleks[nr1][nr2]=handle->syntax.voc_buffer[nr1].fleks[nr2];
											voc_temp_odm[nr1][nr2]=handle->syntax.voc_buffer[nr1].odm[nr2];
											voc_temp_poz[nr1][nr2]=handle->syntax.voc_buffer[nr1].poz[nr2];
										}

                              ile7++;
                              do
                              {
                                 // KATALIZATOR: ZALOZENIE: PODMIOT STOI ZAWSZE PRZED ORZECZENIEM
                                 if (handle->syntaxparams.subject_first==ON)
                                 {
                                    for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
                                    {
                                       if (handle->syntax.clause[akt_zd].function[nr1]==1) break;
                                       else if (handle->syntax.clause[akt_zd].function[nr1]==2) goto FUNKCJE_GRUP_NEXT;
                                    }
                                 }
                                 // KATALIZATOR KONIEC

											// identyfikujemy zaimki rzeczowne osobowe i dzierzawcze
//DeniseReport(handle,"original: ");
//pokaz_rozbior_zdania(handle,&(handle->syntax.clause[akt_zd]));
											if (ext_pronoun_analysis(handle,akt_zd)==FALSE) goto FUNKCJE_GRUP_NEXT;
//DeniseReport(handle,"new version: ");
//pokaz_rozbior_zdania(handle,&(handle->syntax.clause[akt_zd]));
//if (extraction_try>0) DeniseReport(handle,"extr! %d",extraction_try);

/*                                 // KATALIZATOR: ZGODNOSC PODMIOTU W ZALEZNOSCI OD OSOBY Z ROZMOWCA, DENISE I TEMATEM
											// wyraz fleksyjny nr1 - podmiot
	                              for (nr1=0;nr1<handle->syntax.clause[akt_zd].ile_fleks;nr1++)
	                                 if (handle->syntax.clause[akt_zd].function[get_fleksyjny_group(handle,nr1+1)-1]==1) break;

											// wyrazy fleksyjne
	                              for (nr2=0;nr2<handle->syntax.clause[akt_zd].ile_fleks;nr2++)
											{
												nr3=get_fleksyjny_group(handle,nr2+1)-1;
									         poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]];
									         if (poz!=-1) sprintf(dane,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis,poz+'A'-1);
									         else sprintf(dane,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis);

                                    switch (ext_get_person_from_word(handle,dane,handle->syntax.clause[akt_zd].function[nr3]))
												{
													case 0: break;
													case 1:
														nr3=get_fleksyjny_group(handle,nr1+1)-1;
														poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]];
														if (poz!=-1) sprintf(dane,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis,poz+'A'-1);
														else sprintf(dane,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis);
														if (ext_check_subject_person(handle,1,dane,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].fleks[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->podst)==TRUE) goto ZGODNOSC_OK;
														else goto FUNKCJE_GRUP_NEXT;
														break;
													case 2:
														nr3=get_fleksyjny_group(handle,nr1+1)-1;
														poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]];
														if (poz!=-1) sprintf(dane,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis,poz+'A'-1);
														else sprintf(dane,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis);
														if (ext_check_subject_person(handle,2,dane,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].fleks[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->podst)==TRUE) goto ZGODNOSC_OK;
														else goto FUNKCJE_GRUP_NEXT;
													case 3:
														nr3=get_fleksyjny_group(handle,nr1+1)-1;
														poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]];
														if (poz!=-1) sprintf(dane,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis,poz+'A'-1);
														else sprintf(dane,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis);
														if (ext_check_subject_person(handle,3,dane,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].fleks[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->podst)==TRUE) goto ZGODNOSC_OK;
														else goto FUNKCJE_GRUP_NEXT;
												}
                                 }
											ZGODNOSC_OK:
                                 // KATALIZATOR KONIEC
*/
                                 // OCENA GRAMATYCZNA: FUNKCJE WYRAZEN
                                 handle->syntax.clause[akt_zd].quality=quality_temp1;
                                 handle->syntax.clause[akt_zd].ctrl_numbers=ctrl_numb_temp1;

                                 if (gra_funkcje_wyrazen(handle)==0) goto FUNKCJE_GRUP_NEXT;
                                 quality_temp2=handle->syntax.clause[akt_zd].quality;
                                 ctrl_numb_temp2=handle->syntax.clause[akt_zd].ctrl_numbers;
                                 // OCENA GRAMATYCZNA KONIEC
#ifdef PRINT
                                 printf("FUNKCJA: ");
                                 for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
                                    printf("%d ",handle->syntax.clause[akt_zd].function[nr1]);
                                 printf("(%d)\n",handle->syntax.clause[akt_zd].groups_number);
#endif

                                 // ************************************* struktura grup w zdaniu
                                 memset(handle->syntax.clause[akt_zd].parent,(char) 1,handle->syntax.clause[akt_zd].groups_number);
//											memset(handle->syntax.clause[akt_zd].parent_word,(char) 0,handle->syntax.clause[akt_zd].groups_number);
                                 handle->syntax.clause[akt_zd].parent[0]=0; // grupa bez grupy nadrzednej

//if (ext_pronoun_analysis(handle,akt_zd)==FALSE) goto FUNKCJE_GRUP_NEXT;

                                 ile8++;
//                                 printf("ROZBIOR WYPOWIEDZI:\n");
                                 do
                                 {
                                    // KATALIZATOR: PODMIOT BEZ GRUPY NADRZEDNEJ, ORZECZENIE PODRZEDNE DO PODMIOTU
                                    for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
                                    {
                                       if (handle->syntax.clause[akt_zd].function[nr1]==1 && handle->syntax.clause[akt_zd].parent[nr1]!=0) goto STRUKTURA_GRUP_NEXT;
                                       if (handle->syntax.clause[akt_zd].parent[nr1]!=0)
                                          if (handle->syntax.clause[akt_zd].function[nr1]==2 && handle->syntax.clause[akt_zd].function[handle->syntax.clause[akt_zd].parent[nr1]-1]!=1) goto STRUKTURA_GRUP_NEXT;
                                    }
                                    // KATALIZATOR KONIEC
                                    // KATALIZATOR
                                    if (droga_funkcyjna(handle)==0) goto STRUKTURA_GRUP_NEXT;
                                    // KATALIZATOR KONIEC

#ifdef PRINT
                                    printf("STRUKTURA: ");
                                    for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
                                       printf("%d ",handle->syntax.clause[akt_zd].parent[nr1]);
                                    printf("(%d)\n",handle->syntax.clause[akt_zd].groups_number);
#endif

                                    // OCENA GRAMATYCZNA: ZWIAZKI MIEDZY WYRAZENIAMI
                                    handle->syntax.clause[akt_zd].quality=quality_temp2;
                                    handle->syntax.clause[akt_zd].ctrl_numbers=ctrl_numb_temp2;

//pokaz_rozbior_zdania(handle,&(handle->syntax.clause[akt_zd]));


                                    if (gra_struktura(handle)==0) goto STRUKTURA_GRUP_NEXT;
                                    // OCENA GRAMATYCZNA KONIEC
//DeniseReport(handle,"kopc");

                                    ile9++;

                                    // OCENA gramatyczna danego zdania pojedynczego
                                    gra_ocen_zdanie(handle);

                                    // obliczenie jakosci: 0-100%
                                    handle->syntax.clause[akt_zd].quality=handle->syntax.clause[akt_zd].quality/handle->syntax.clause[akt_zd].ctrl_numbers;
                                    // OCENA KONIEC

                                    // wypisanie rozbioru danego zdania
												if (handle->viewparams.clause==ON)
												{
													DeniseReport(handle,UNN_GetLocaleString(handle,MSG_CLAUSE_ANALYSIS,"* rozbior zdania pojedynczego: %d (jakosc: %d%%)"),akt_zd+1,handle->syntax.clause[akt_zd].quality);
 	                                    pokaz_rozbior_zdania(handle,&(handle->syntax.clause[akt_zd]));
												}
//printf("ocena: %d%%\n",handle->syntax.clause[akt_zd].quality);
//goto STRUKTURA_GRUP_NEXT;
// NO OK

                                    // jesli jakosc tego zdania jest mniejsza od aktualnie pamietanej analizy to pomijamy
//                                    if (handle->syntax.accepted[akt_zd][ile_accepted].quality>=handle->syntax.clause[akt_zd].quality) goto STRUKTURA_GRUP_NEXT;

                                    // zapamietujemy rozbior
                                    handle->syntax.accepted[akt_zd][ile_accepted].quality=handle->syntax.clause[akt_zd].quality;
                                    handle->syntax.accepted[akt_zd][ile_accepted].ctrl_numbers=handle->syntax.clause[akt_zd].ctrl_numbers;
                                    handle->syntax.accepted[akt_zd][ile_accepted].words_number=handle->syntax.clause[akt_zd].words_number;
                                    handle->syntax.accepted[akt_zd][ile_accepted].ile_fleks=handle->syntax.clause[akt_zd].ile_fleks;
                                    handle->syntax.accepted[akt_zd][ile_accepted].groups_number=handle->syntax.clause[akt_zd].groups_number;

												for (nr1=0;nr1<100;nr1++)
                                    {
	                                    handle->syntax.accepted[akt_zd][ile_accepted].wyrazy[nr1]=handle->syntax.clause[akt_zd].wyrazy[nr1];
	                                    handle->syntax.accepted[akt_zd][ile_accepted].fleksyjny[nr1]=handle->syntax.clause[akt_zd].fleksyjny[nr1];
	                                    handle->syntax.accepted[akt_zd][ile_accepted].member[nr1]=handle->syntax.clause[akt_zd].member[nr1];
	                                    handle->syntax.accepted[akt_zd][ile_accepted].parent[nr1]=handle->syntax.clause[akt_zd].parent[nr1];
													handle->syntax.accepted[akt_zd][ile_accepted].parent_word[nr1]=handle->syntax.clause[akt_zd].parent_word[nr1];
	                                    handle->syntax.accepted[akt_zd][ile_accepted].function[nr1]=handle->syntax.clause[akt_zd].function[nr1];
	                                    handle->syntax.accepted[akt_zd][ile_accepted].posneg[nr1]=handle->syntax.clause[akt_zd].posneg[nr1];
												}

											   for (nr1=0;nr1<handle->syntax.accepted[akt_zd][ile_accepted].ile_fleks;nr1++)
											   {
											     	strcpy(handle->syntax.accepted[akt_zd][ile_accepted].voc_data[nr1].wyraz,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[nr1]].wyraz);
											   	handle->syntax.accepted[akt_zd][ile_accepted].voc_data[nr1].fleks=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[nr1]].fleks[handle->syntax.clause[akt_zd].fleks_nr[nr1]];
											   	handle->syntax.accepted[akt_zd][ile_accepted].voc_data[nr1].odm=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[nr1]].odm[handle->syntax.clause[akt_zd].fleks_nr[nr1]];
											     	handle->syntax.accepted[akt_zd][ile_accepted].voc_data[nr1].poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[nr1]].poz[handle->syntax.clause[akt_zd].fleks_nr[nr1]];
											   }

											   for (nr1=0;nr1<handle->syntax.accepted[akt_zd][ile_accepted].groups_number;nr1++)
											   {
													strcpy(handle->syntax.accepted[akt_zd][ile_accepted].group_fleks[nr1],handle->syntax.clause[akt_zd].group_fleks[nr1]);
											   }

//                                    memcpy(&(handle->syntax.accepted[akt_zd]),&(handle->syntax.clause[akt_zd]),sizeof(struct Clause));

                                    // wypisanie rozbioru danego zdania
//                                    pokaz_rozbior_zdania(handle,&(handle->syntax.clause[akt_zd]));

                                    byla_ocena=1;
                                    handle->syntax.ile_accepted[akt_zd]++;
												ile_accepted=handle->syntax.ile_accepted[akt_zd];
                                    STRUKTURA_GRUP_NEXT: ;
                                 }
                                 while (struktura_grup(handle)!=0);
                                 FUNKCJE_GRUP_NEXT: ;
                                 // tu nalezy przywrocic wszystkie dane fleksyjne, jesli zostaly
                                 // zinterpretowane przez "pronoun_analysis", bo po zmianie funkcji analiza musi byc inna
											for (nr1=0;nr1<handle->syntax.buffer_len;nr1++)
											for (nr2=0;nr2<handle->syntax.voc_buffer[nr1].fleks_ile;nr2++)
											{
         	                     	handle->syntax.voc_buffer[nr1].fleks[nr2]=voc_temp_fleks[nr1][nr2];
												handle->syntax.voc_buffer[nr1].odm[nr2]=voc_temp_odm[nr1][nr2];
												handle->syntax.voc_buffer[nr1].poz[nr2]=voc_temp_poz[nr1][nr2];
											}
                              }
                              while (funkcje_grup(handle)!=0);
                              FLEKSJA_FLEKSYJNYCH_NEXT: ;
                           }
                           while (new_fleksja_fleksyjnych(handle)!=0);
                           WYRAZY_FLEKSYJNE_NEXT: ;
                        } // podzial na wyrazy fleksyjne
                        while (universal_bell(handle->syntax.clause[akt_zd].fleksyjny,&handle->syntax.clause[akt_zd].ile_fleks,handle->syntax.clause[akt_zd].words_number)!=0);
                        PODZIAL_GRUP_NEXT: ;
                     } // podzial na grupy
                     while (universal_bell(handle->syntax.clause[akt_zd].member,&handle->syntax.clause[akt_zd].groups_number,handle->syntax.clause[akt_zd].words_number)!=0);

                     // jesli nie doszlo do ocenienia zdania, rezygnujemy z calego rozbioru
                     if (byla_ocena==0) goto STRUKTURA_ZDAN_NEXT;
                  }

                  // *******************************************************************************
                  // OCENA gramatyczna danego rozbioru wszystkich zdan
                  ile10++;
//goto STRUKTURA_ZDAN_NEXT;
//return NULL;
						// generowanie faktu:
						// wszystkie mozliwosci:
                  // 1 rozbior 1 zdania + 1 rozb. 2 zdania + 2 rozb. 2 zdania itd...
						for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
							handle->syntax.active[nr1]=0;
                  do
                  {
	                  // obliczenie jakosci calej wypowiedzi: 0-100%
	                  for (nr1=0,nr2=0;nr1<handle->syntax.clause_number;nr1++)
	                     nr2+=handle->syntax.accepted[nr1][handle->syntax.active[nr1]].quality;
	                  nr2=nr2/handle->syntax.clause_number;

	                  // jesli jakosc jest mniejsza od aktualnie pamietanej analizy to nie zapamietujemy nowej
//                  if (nr2<quality) goto STRUKTURA_ZDAN_NEXT;
	                  quality=nr2;

	                  // zapamietanie rozbioru calej wypowiedzi - jesli nie mozna, to blad
	                  if ((fact_new=fact_remember(handle))==NULL)
	                  {
								DeniseReport(handle,UNN_GetLocaleString(handle,MSG_ERROR_IN_FACT_REMEMBER,"blad: nie moge zapamietac faktu!"));
	                     return NULL;
	                  }

					  // sprawdzamy, czy istnieje juz identyczny fakt - jesli tak, to rezygnujemy z niego
					  if (find_fact(fact,fact_new)!=NULL)
					  {
						  fact_free(fact_new);
						  free(fact_new);
						  fact_new=NULL;
					  }
					  else
					  {
					  // wypisanie rozbioru calej wypowiedzi
						if (handle->viewparams.syntax==ON)
						{
							DeniseReport(handle,UNN_GetLocaleString(handle,MSG_SENTENCE_ANALYSIS,"*** rozbior wypowiedzi ***"));
							for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
	   						{
	      						pokaz_rozbior_zaakceptowany(handle,&(handle->syntax.accepted[nr1][handle->syntax.active[nr1]]));
	         					if (nr1<handle->syntax.clause_number-1)
	            				{
	               				switch (handle->syntax.logic_tree[nr1])
	                  			{
	                     	      case CON_AND: DeniseReport(handle,"AND"); break;
	                        	  case CON_XOR: DeniseReport(handle,"XOR"); break;
	                        	  case CON_THEN: DeniseReport(handle,"THEN"); break;
	                        	  case CON_OR: DeniseReport(handle,"OR"); break;
		                           default:
												DeniseReport(handle,UNN_GetLocaleString(handle,MSG_WRONG_LOGIC_OPERATOR,"bledny operator logiczny!"));
	                             		break;
	   	                     }
	      	               }
	         	         }
						}

	                  // jesli jest pamietany jakis rozbior to zwalniamy pamiec
//                  if (fact!=NULL) {fact_free(fact);free(fact);}

						// dopisujeny fakt do listy
						if (fact==NULL) fact=fact_new;
						else fact_last->next=fact_new;
						fact_last=fact_new;
					  }
					}
                  while (aktywne_rozbiory(handle)!=0);

                  if (handle->syntaxparams.remember_first==ON) goto KONIEC_ANALIZY;
                  // *******************************************************************************
                  STRUKTURA_ZDAN_NEXT: ;
               }
               while (struktura_zdan(handle)!=0);
               ZDANIA_POJEDYNCZE_NEXT: ;
/*
					// jesli nie udalo sie zidentyfikowac zdania, to probujemy ekstrakcji
					if (fact==NULL && extraction_try<=3)
               {
	               for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
   	            {
      	            handle->syntax.clause[nr1].words_number=handle->syntax.podzial[nr1].words_number;
         	         for (nr2=0;nr2<handle->syntax.clause[nr1].words_number;nr2++)
            	         handle->syntax.clause[nr1].wyrazy[nr2]=handle->syntax.podzial[nr1].wyrazy[nr2];
	               }
						if (extraction_try==0) handle->syntax.words_number++;

						switch (extraction_try)
                  {
                  	case 0: // 1 osoba
								sprintf(handle->syntax.words[handle->syntax.words_number-1].orig,"ja");
                        break;
							case 1: // 2 osoba
								sprintf(handle->syntax.words[handle->syntax.words_number-1].orig,"ty");
                     	break;
                     case 2: // 3 osoba - r. m.
								sprintf(handle->syntax.words[handle->syntax.words_number-1].orig,"on");
                     	break;
                     case 3: // 3 osoba - r. z.
								sprintf(handle->syntax.words[handle->syntax.words_number-1].orig,"ona");
                     	break;
               	}

//sprintf(handle->syntax.words[handle->syntax.words_number-1].orig,"on");
DeniseReport(handle,"EXTR: %s (%d)",handle->syntax.words[handle->syntax.words_number-1].orig,handle->syntax.words_number-1);

			         handle->syntax.words[handle->syntax.words_number-1].zrost_nr=0;
			         handle->syntax.words[handle->syntax.words_number-1].ile_mozliwosci=1;
			         handle->syntax.words[handle->syntax.words_number-1].zrost_poz[0]=strlen(handle->syntax.words[handle->syntax.words_number-1].orig);
			         handle->syntax.words[handle->syntax.words_number-1].priority=0;
			         handle->syntax.words[handle->syntax.words_number-1].fleks_buff_nr=0;
			         handle->syntax.words[handle->syntax.words_number-1].fleks_nr=0;

      	         for (nr2=0;nr2<handle->syntax.clause[0].words_number;nr2++)
     	   	         handle->syntax.clause[0].wyrazy[nr2+1]=handle->syntax.podzial[0].wyrazy[nr2];
						handle->syntax.clause[0].words_number++;
						handle->syntax.clause[0].wyrazy[0]=&handle->syntax.words[handle->syntax.words_number-1];

   // aktualna fleksja wyrazu modyfikujacego w tym wyrazie modyfikujacym,
//   int fleks_buff_nr;
//   int fleks_nr;

               	extraction_try++;
//extraction_try=4;
                  goto ZDANIA_POJEDYNCZE_WITH_EXT;
               }

					if (extraction_try>0)
               {
						handle->syntax.words_number--;
                  extraction_try=0;
               }
*/
            }
            while (zdania_pojedyncze(handle)!=0);
         }
         while (fleksja_modyfikatora(handle)!=0);
         PRIORYTET_ZROSTU_NEXT: ;
      }
      while (priorytet_zrostu(handle)!=0);
   }
   while (check_zrosty(handle->syntax.words,handle->syntax.words_number)!=0);

   // EXTRACTION
	// jesli nie udalo sie zidentyfikowac zdania, to probujemy ekstrakcji
	if (fact==NULL && extraction_try<=3)
   {
		switch (extraction_try)
      {
   	 	case 0: // 1 osoba
				sprintf(handle->syntax.busy,"ja %s",temp_busy);
         	break;
			case 1: // 2 osoba
				sprintf(handle->syntax.busy,"ty %s",temp_busy);
            break;
         case 2: // 3 osoba - r. m.
				sprintf(handle->syntax.busy,"on %s",temp_busy);
           	break;
         case 3: // 3 osoba - r. z.
				sprintf(handle->syntax.busy,"ona %s",temp_busy);
           	break;
      }

     	extraction_try++;

//extraction_try=4;
      goto BEGIN_ANALYSIS;
	}
   // EXTRACTION END

   if (ile6==0) DeniseMessage(handle,UNN_GetLocaleString(handle,MSG_WORDS_NOT_FOUND,"nie odnaleziono wyrazu lub wyrazow w bazie fleksji"));
   if (ile10==0)
   {
		DeniseMessage(handle,UNN_GetLocaleString(handle,MSG_SENTENCE_ANALYSIS_FAILED,"nie potrafie dokonac rozbioru zdania"));
		if (handle->logbookparams.clauses==ON) log_unknown_clause(handle,handle->syntax.orig);
   }

   KONIEC_ANALIZY: ;

//	DeniseReport(handle,"ile1=%d,ile2=%d,ile3=%d,ile4=%d,ile5=%d,ile6=%d,ile7=%d,ile8=%d,ile9=%d,ile10=%d",ile1,ile2,ile3,ile4,ile5,ile6,ile7,ile8,ile9,ile10);

   czas=clock()-czas;
//   printf("CZAS: %d\nile1: %ld\nile2: %ld\nile3: %ld\nile4: %ld\nile5: %ld\nile6: %ld\nile7: %ld\nile8: %ld\nile9: %ld\nile10: %ld\n",czas,ile1,ile2,ile3,ile4,ile5,ile6,ile7,ile8,ile9,ile10);
//   printf("CZAS: %d\nile1: %ld, ile2: %ld, ile3: %ld, ile4: %ld, ile5: %ld, ile6: %ld, ile7: %ld, ile8: %ld\nile9: %ld\nile10: %ld\n",czas,ile1,ile2,ile3,ile4,ile5,ile6,ile7,ile8,ile9,ile10);

	if (handle->viewparams.syntax_time==ON)
	{
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_SENTENCE_ANALYSIS_TIME,"czas analizy gramatycznej: %ds"),czas/CLK_TCK);
	}

   if (fact==NULL) strcpy(handle->syntax.busy,temp_busy);

   return fact;
}

static struct Fact *find_fact(struct Fact *lista,struct Fact *fact)
{
	// funkcja szuka faktu fact na liscie faktow lista
	// zwraca wskaznik jesli znajdzie taki sam

	struct Fact *factA;
	struct FactSimple *fsA,*fsB;
	int nr1;

	if (lista==NULL || fact==NULL) return NULL;

	for (factA=lista;factA!=NULL;factA=factA->next)
	{
		if (factA->ile_klauzul!=fact->ile_klauzul) continue;
		for (nr1=0;nr1<factA->ile_klauzul;nr1++)
			if (strcmp(factA->logic[nr1],fact->logic[nr1])!=0) goto NEXT_FACT;
		
		for (fsA=factA->fs,fsB=fact->fs;fsA!=NULL && fsB!=NULL;fsA=fsA->next,fsB=fsB->next)
		{
			if ((fsA==NULL && fsB!=NULL) || (fsA!=NULL && fsB==NULL)) goto NEXT_FACT;
			if (fsA->quality!=fsB->quality) goto NEXT_FACT;
			if (strcmp(fsA->sentence->base_words,fsB->sentence->base_words)!=0) goto NEXT_FACT;
			if (strcmp(fsA->sentence->fleksyjny,fsB->sentence->fleksyjny)!=0) goto NEXT_FACT;
//			if (strcmp(fsA->sentence->function,fsB->sentence->function)!=0) goto NEXT_FACT;
			if (strcmp(fsA->sentence->member,fsB->sentence->member)!=0) goto NEXT_FACT;
			if (strcmp(fsA->sentence->parent,fsB->sentence->parent)!=0) goto NEXT_FACT;
			if (strcmp(fsA->sentence->voc,fsB->sentence->voc)!=0) goto NEXT_FACT;
			if (strcmp(fsA->sentence->words,fsB->sentence->words)!=0) goto NEXT_FACT;
		}
		return factA;
		NEXT_FACT:;
	}

	return NULL;
}

static int check_stream(int *stream,int ile,int grupa)
{
   int nr1;

   for (nr1=0;nr1<ile;nr1++)
      if (stream[nr1]==grupa) return 1;

   return 0;
}

static struct Fact* fact_remember(struct DeniseHandle* handle)
{
	/*

   tworzenie strumieni:
	- dla kolejnych zdan tworzymy zdania jednorodne polaczone AND:
		- pobieramy kolejne grupy, ktore nie maja grup podrzednych,
		- tworzymy fakt prosty, ktory dodajemy do listy fs:
			- tworzymy ciag grup - strumien,
			- wpisujemy od nadrzednej do podrzednej,

   np.
	       INFORMATION
            polski
            marek+AABAAA
            marek jest niemiy	ORIG
            marek jest niemiy	WORDS wyrazy podstawowe ulozone wyrazami fleksyjnymi (!aa a,b b+b,c c c)
            marek,by,!nie+miy	BASE_WORDS
            AABAAA,BAABAEEAC,GAAAAA VOC

         INFORMATION
            polski
            dariusz+AABAAA

            darek nie jest miy
            darek nie jest miy
            dariusz,!nie,by,miy
            AABAAA,PB,BAABAEEAC,GAAAAA
   */

   struct GrammarData *gr_data;
	struct Fact *fact;
	struct FactSimple *fs_head,*fs_last,*fs;
	int nr1,nr2,nr3,nr4,nr5,stream[10],test[10],stream_groups,fs_counter,poz,rozbior_nr;
	char logic[1000],logic_stream[1000]; // opis struktury logicznej wypowiedzi,
	char plus[2],con_and[2],nawias_open[2],nawias_close[2],przecinek[2],space[2],negacja[2],temp[1000],temp1[1000];
   char dane_fleks[100];
   char voc[1000],words[1000],member[100],fleksyjny[100],priority[100],zrost_poz[100],base_words[1000];

	sprintf(con_and,"%d",CON_AND);
	sprintf(nawias_open,"(");
	sprintf(nawias_close,")");
	sprintf(przecinek,",");
	sprintf(negacja,"!");
	sprintf(space," ");
   sprintf(plus,"+");
	fs_counter=0;

	logic[0]='\0';
	fs_head=NULL;

	// dla kolejnych zdan tworzymy zdania jednorodne polaczone AND:
   for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
   {
   	rozbior_nr=handle->syntax.active[nr1];

		logic_stream[0]='\0';
		// szukamy grup, ktore nie maja grupy podrzednej
		for (nr2=0;nr2<handle->syntax.accepted[nr1][rozbior_nr].groups_number;nr2++)
		{
			// czy ma podrzedna?
			for (nr3=0;nr3<handle->syntax.accepted[nr1][rozbior_nr].groups_number;nr3++)
				if (handle->syntax.accepted[nr1][rozbior_nr].parent[nr3]==nr2+1) goto NEXT_STREAM;

			// skoro nie ma podrzednej, to mamy strumien
			// tworzymy ciag grup - strumien
			for (stream_groups=1,stream[0]=nr2+1;
				  handle->syntax.accepted[nr1][rozbior_nr].parent[stream[stream_groups-1]-1]!=0;
				  stream[stream_groups++]=handle->syntax.accepted[nr1][rozbior_nr].parent[stream[stream_groups-1]-1]);

         // musimy odwrocic strumien
         for (nr3=0;nr3<stream_groups;nr3++) test[stream_groups-nr3-1]=stream[nr3];
         for (nr3=0;nr3<stream_groups;nr3++) stream[nr3]=test[nr3];

			// tworzymy fakt prosty z tym strumieniem
	      if ((fs=malloc(sizeof(struct FactSimple)))==NULL) return NULL;
	      fs->next=NULL;
	      fs->quality=handle->syntax.accepted[nr1][rozbior_nr].quality;
         fs->theme_number=0;

   	   if ((fs->sentence=malloc(sizeof(struct FSentence)))==NULL) return NULL;
//	      fs->sentence->language=NULL;
	      fs->sentence->id_subject=NULL;
   	   fs->sentence->id_global=NULL;
//      	fs->sentence->orig=NULL;
//	      fs->sentence->words=NULL;
//   	   fs->sentence->base_words=NULL;
//      	fs->sentence->voc=NULL;
//	      fs->sentence->group_voc=NULL;
//   	   fs->sentence->zrost_poz=NULL;
//      	fs->sentence->priority=NULL;
//	      fs->sentence->fleksyjny=NULL;
//   	   fs->sentence->member=NULL;
//      	fs->sentence->parent=NULL;
//	      fs->sentence->parent_word=NULL;
//   	   fs->sentence->function=NULL;
//      	fs->sentence->posneg=NULL;
//	      fs->sentence->words_number=0;
//	      fs->sentence->groups_number=0;
//	      fs->sentence->ile_fleks=0;

	      if ((fs->sentence->language=malloc(strlen(handle->language.name)+1))==NULL) return NULL;
   	      strcpy(fs->sentence->language,handle->language.name);

	      if ((fs->sentence->orig=malloc(strlen(handle->syntax.orig)+1))==NULL) return NULL;
   	      strcpy(fs->sentence->orig,handle->syntax.orig);

	      fs->sentence->groups_number=stream_groups;

	      if ((fs->sentence->parent=malloc(stream_groups+1))==NULL) return NULL;
	      if ((fs->sentence->parent_word=malloc(stream_groups+1))==NULL) return NULL;
	      if ((fs->sentence->function=malloc(stream_groups+1))==NULL) return NULL;
	      if ((fs->sentence->posneg=malloc(stream_groups+1))==NULL) return NULL;
			temp[0]='\0';
			for (nr3=0;nr3<stream_groups;nr3++)
			{
				fs->sentence->parent[nr3]=nr3;
				fs->sentence->parent_word[nr3]=handle->syntax.accepted[nr1][rozbior_nr].parent_word[stream[nr3]-1]==0 ? 0 : 1;
				fs->sentence->function[nr3]=handle->syntax.accepted[nr1][rozbior_nr].function[stream[nr3]-1];
				fs->sentence->posneg[nr3]=handle->syntax.accepted[nr1][rozbior_nr].posneg[stream[nr3]-1];

				if (temp[0]!='\0') strcat(temp,przecinek);
	  			strcat(temp,handle->syntax.accepted[nr1][rozbior_nr].group_fleks[stream[nr3]-1]);
			}
	      if ((fs->sentence->group_voc=malloc(strlen(temp)+1))==NULL) return NULL;
			strcpy(fs->sentence->group_voc,temp);

			/*
			pobieramy kolejne wyrazy fleksyjne w tej grupie
			- pobieramy fleksje wyrazu fleksyjnego,
			- wpisujemy fleksje do voc (tylko glowne),
			- wpisujemy wyraz fleksyjny do base_words - bierzemy pod uwage zrosty,
			- wpisujemy wyrazy odseparowane tego wyrazu fleksyjnego do words,
			- zaznaczamy wpisywane wyrazy: member, fleksyjny, priority, zrost_poz,
			  oraz zwiekszamy ich liczbe,
         */

	      fs->sentence->words_number=0;
	      fs->sentence->ile_fleks=0;

			voc[0]='\0';
			words[0]='\0';
//			priority[0]='\0';
//			zrost_poz[0]='\0';
//			fleksyjny[0]='\0';
			base_words[0]='\0';
			// dla kolejnych grup

			for (nr3=0;nr3<stream_groups;nr3++)
			{
         	// szukamy kolejnych wyrazow fleksyjnych, ktore do niej naleza
            for (nr4=0;nr4<handle->syntax.accepted[nr1][rozbior_nr].ile_fleks;nr4++)
            {
            	// czy nalezy do tej grupy?
               for (nr5=0;nr5<handle->syntax.accepted[nr1][rozbior_nr].words_number;nr5++)
               	if (handle->syntax.accepted[nr1][rozbior_nr].fleksyjny[nr5]==nr4+1 && handle->syntax.accepted[nr1][rozbior_nr].member[nr5]==stream[nr3]) goto FLEKS_NALEZY;
					// jesli nie nalezy, to nastepny fleksyjny moze?
               continue;

               // jesli nalezy...
					FLEKS_NALEZY:;
					// mamy:
               // nr3+1 - numer grupy w FS
               // stream[nr3] - numer tej grupy w SYNTAX
               // nr4+1 - numer wyrazu fleksyjnego w SYNTAX
					// fs->sentence->ile_fleks - liczba wyrazow fleksyjnych w FS
					// fs->sentence->words_number - liczba wyrazow odseparowanych w FS
               //
					// pobieramy fleksje wyrazu fleksyjnego,
		         poz=handle->syntax.accepted[nr1][rozbior_nr].voc_data[nr4].poz;
		         if (poz!=-1) sprintf(dane_fleks,"%s%c",handle->syntax.accepted[nr1][rozbior_nr].voc_data[nr4].odm->opis,poz+'A'-1);
		         else sprintf(dane_fleks,"%s",handle->syntax.accepted[nr1][rozbior_nr].voc_data[nr4].odm->opis);

					// wpisujemy fleksje do voc (tylko glowne),
					if (voc[0]!='\0') strcat(voc,przecinek);
               strcat(voc,dane_fleks);

               // wpisujemy wyrazy odseparowane tego wyrazu fleksyjnego do words,
               // mozliwe, ze zmieniamy kolejnosc oryginalnego zapisu,
               // ale czy tak nie przyjemniej?
               // musimy zapisac wszystkie wyrazy odseparowane tego wyrazu fleksyjnego
               for (nr5=0;nr5<handle->syntax.accepted[nr1][rozbior_nr].words_number;nr5++)
               {
               	// jesli to fragment dopisywanego wyrazu fleksyjnego...
               	if (handle->syntax.accepted[nr1][rozbior_nr].fleksyjny[nr5]==nr4+1)
                  {
                  	// to dopisujemy go do words
                     if (words[0]!='\0') strcat(words,space);
							strcat(words,handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->orig);
							// dopisujemy tez informacje w member
                     member[fs->sentence->words_number]=nr3+1;
                     // oraz we fleksyjnym
                     fleksyjny[fs->sentence->words_number]=fs->sentence->ile_fleks+1;
							// oraz jego priority...
                     priority[fs->sentence->words_number]=handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->priority;
							// i zrost_poz
            			zrost_poz[fs->sentence->words_number]=handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->zrost_poz[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->zrost_nr];
							// i... zwiekszamy ich liczbe
                     fs->sentence->words_number++;
                  }
               }

					// wpisujemy wyraz fleksyjny do base_words kolejne wyrazy fleksyjne
					// laczymy wszystkie wyrazy odseparowane tego wyrazu fleksyjnego:
					// zapis kazdego wyrazu odseparowanego: przedrostek+reszta
               temp[0]='\0'; // tu bedzie wyraz fleksyjny, potem sie go dopisze do reszty
               for (nr5=0;nr5<handle->syntax.accepted[nr1][rozbior_nr].words_number;nr5++)
               {
               	// jesli to fragment dopisywanego wyrazu fleksyjnego...
               	if (handle->syntax.accepted[nr1][rozbior_nr].fleksyjny[nr5]==nr4+1)
                  {
                     if (temp[0]!='\0') strcat(temp,space);

							// jesli przedrostek jest NEGACJA to zapisujemy
			            // jesli wyraz odseparowany nie ma modyfikatora to pomijamy
                     if (handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->zrost_poz[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->zrost_nr]!=(int) strlen(handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->orig))
                     {
				            // pobieramy fleksje wyrazu modyfikujacego
				            poz=handle->syntax.voc_buffer[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->fleks_buff_nr].poz[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->fleks_nr];
				            if (poz!=-1) sprintf(dane_fleks,"%s%c",handle->syntax.voc_buffer[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->fleks_buff_nr].odm[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->fleks_nr]->opis,poz+'A'-1);
				            else sprintf(dane_fleks,"%s",handle->syntax.voc_buffer[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->fleks_buff_nr].odm[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->fleks_nr]->opis);

				            // sprawdzamy dla kolejnych wyrazow negujacych grupy
				            for (gr_data=handle->language.lo1;gr_data!=NULL;gr_data=gr_data->next)
				            {
				               if (strlen(gr_data->data)>strlen(dane_fleks)) continue;

				               // jesli modyfikator NEGuje to dodajemy NEGacje
				               if (strncmp(gr_data->data,dane_fleks,strlen(dane_fleks))==0)
				               {
										strcat(temp,negacja);
				                  break;
				               }
				            }
 								// zapis kazdego wyrazu odseparowanego: przedrostek+reszta
		  		            if (handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->priority==0) sprintf(temp1,"%s+",handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->orig+handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->zrost_poz[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->zrost_nr]);
				            else sprintf(temp1,"%.*s+",handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->zrost_poz[handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->zrost_nr],handle->syntax.accepted[nr1][rozbior_nr].wyrazy[nr5]->orig);
                        strcat(temp,temp1);
                     }

							// teraz bierzemy sie za wyraz glowny
				         poz=handle->syntax.accepted[nr1][rozbior_nr].voc_data[nr4].poz;
				         if (poz!=-1) sprintf(dane_fleks,"%s%c",handle->syntax.accepted[nr1][rozbior_nr].voc_data[nr4].odm->opis,poz+'A'-1);
				         else sprintf(dane_fleks,"%s",handle->syntax.accepted[nr1][rozbior_nr].voc_data[nr4].odm->opis);

				         // sprawdzamy dla kolejnych wyrazow negujacych grupy
				         for (gr_data=handle->language.lo1;gr_data!=NULL;gr_data=gr_data->next)
				         {
				            if (strlen(gr_data->data)>strlen(dane_fleks)) continue;

				            // jesli wyraz NEGuje to dodajemy NEGacje
				            if (strncmp(gr_data->data,dane_fleks,strlen(dane_fleks))==0)
				            {
									strcat(temp,negacja);
				               break;
				            }
				         }

							// dopisujemy do listy temp wyrazow odseparowanych
                     strcat(temp,handle->syntax.accepted[nr1][rozbior_nr].voc_data[nr4].fleks->podst);
                  }
               }

					// dopisujemy nowy wyraz fleksyjny do reszty w base_words
               if (base_words[0]!='\0') strcat(base_words,przecinek);
               strcat(base_words,temp);

               // zwiekszamy liczbe wyrazow fleksyjnych
					fs->sentence->ile_fleks++;
            }
			}
	      if ((fs->sentence->words=malloc(strlen(words)+1))==NULL) return NULL;
			strcpy(fs->sentence->words,words);

//DeniseMessage(handle,"WORDS: %s",words);

	      if ((fs->sentence->base_words=malloc(strlen(base_words)+1))==NULL) return NULL;
			strcpy(fs->sentence->base_words,base_words);

//DeniseMessage(handle,"BASE: %s",base_words);

	      if ((fs->sentence->voc=malloc(strlen(voc)+1))==NULL) return NULL;
			strcpy(fs->sentence->voc,voc);

//DeniseMessage(handle,"VOC: %s",voc);

	      if ((fs->sentence->member=malloc(fs->sentence->words_number+1))==NULL) return NULL;
	      if ((fs->sentence->fleksyjny=malloc(fs->sentence->words_number+1))==NULL) return NULL;
	      if ((fs->sentence->zrost_poz=malloc(fs->sentence->words_number+1))==NULL) return NULL;
	      if ((fs->sentence->priority=malloc(fs->sentence->words_number+1))==NULL) return NULL;

         for (nr3=0;nr3<fs->sentence->words_number;nr3++)
         {
         	fs->sentence->member[nr3]=member[nr3];
         	fs->sentence->fleksyjny[nr3]=fleksyjny[nr3];
         	fs->sentence->zrost_poz[nr3]=zrost_poz[nr3];
         	fs->sentence->priority[nr3]=priority[nr3];
         }
       	fs->sentence->member[nr3]='\0';
        	fs->sentence->fleksyjny[nr3]='\0';
        	fs->sentence->zrost_poz[nr3]='\0';
        	fs->sentence->priority[nr3]='\0';

	      ide_get_fsent_id(handle,fs->sentence,temp,ID_FROM_SUBJECT);
	      if (strlen(temp)>0)
	      {
	         if ((fs->sentence->id_subject=malloc(strlen(temp)+1))==NULL) return NULL;
            strcpy(fs->sentence->id_subject,temp);
	      }

	      ide_get_fsent_id(handle,fs->sentence,temp,ID_FROM_OTHER);
	      if (strlen(temp)==0) fs->sentence->id_global=NULL;
	      else
	      {
	         if ((fs->sentence->id_global=malloc(strlen(temp)+1))==NULL) return NULL;
	            strcpy(fs->sentence->id_global,temp);
	      }

			// dopisujemy do listy fs tego zdania
			if (fs_head==NULL) fs_head=fs;
			else fs_last->next=fs;
			fs_last=fs;

			// logika
			if (logic_stream[0]!='\0') strcat(logic_stream,con_and);
			sprintf(temp,"%c",'A'+fs_counter++);
			strcat(logic_stream,temp);

			NEXT_STREAM:;
		}
		// dopisujemy nowa liste do calej wypowiedzi
		if (nr1>0)
		{
			sprintf(temp,"%d",handle->syntax.logic_tree[nr1-1]);
			strcat(logic,temp);
		}

		if (strlen(logic_stream)>1) strcat(logic,nawias_open);
		strcat(logic,logic_stream);
		if (strlen(logic_stream)>1) strcat(logic,nawias_close);
	}

   // tworzymy nowy fakt
   fact=malloc(sizeof(struct Fact));
   fact->next=NULL;
   fact->ile_klauzul=0;
   fact->logic=NULL;
   glo_current_time(fact->time,0);
   fact->fs=fs_head;

   // logiczny opis faktu
   if (log_expr_simplification(logic,temp1)==-1)
   {
	   DeniseReport(handle,"blad: akceptuje max. 1 xor i 1 then");
		return NULL;
   }

//   DeniseReport(handle,"%s,%s",logic,temp1);


   log_expr2clause(handle,temp1,logic);

//printf("zdanie: %s\n",temp1);

   fact->ile_klauzul=glo_count_parts(handle,logic,',');
   fact->logic=(char **) malloc(fact->ile_klauzul*sizeof(char *));

   for (nr1=0;nr1<fact->ile_klauzul;nr1++)
   {
      glo_get_part(logic,nr1+1,temp1,',');
      fact->logic[nr1]=(char *) malloc(strlen(temp1)+1);
      memcpy(fact->logic[nr1],temp1,strlen(temp1)+1);
   }

//DeniseReport(handle,"LOGIKA: %s",temp1);
//   log_expr_description(temp1);

   return fact;
}

static void fact_free(struct Fact *fact)
{
   // funkcja zwalnia pamiec zajmowana przez dany fakt prosty

   struct FactSimple *fs1,*fsnext;

   if (fact==NULL) return;

   for (fs1=fact->fs;fs1!=NULL;fs1=fsnext)
   {
      fsnext=fs1->next;

      if (fs1->sentence==NULL) continue;

      if (fs1->sentence->language) free(fs1->sentence->language);
      if (fs1->sentence->id_subject) free(fs1->sentence->id_subject);
      if (fs1->sentence->id_global) free(fs1->sentence->id_global);
      if (fs1->sentence->orig) free(fs1->sentence->orig);
      if (fs1->sentence->words) free(fs1->sentence->words);
      if (fs1->sentence->base_words) free(fs1->sentence->base_words);
      if (fs1->sentence->voc) free(fs1->sentence->voc);
      if (fs1->sentence->group_voc) free(fs1->sentence->group_voc);
      if (fs1->sentence->zrost_poz) free(fs1->sentence->zrost_poz);
      if (fs1->sentence->priority) free(fs1->sentence->priority);
      if (fs1->sentence->fleksyjny) free(fs1->sentence->fleksyjny);
      if (fs1->sentence->member) free(fs1->sentence->member);
      if (fs1->sentence->parent) free(fs1->sentence->parent);
      if (fs1->sentence->parent_word) free(fs1->sentence->parent_word);
      if (fs1->sentence->function) free(fs1->sentence->function);

      free(fs1->sentence);
      free(fs1);
   }
   if (fact->logic) free(fact->logic);
//   free(fact);
}

static void check_pos_neg(struct DeniseHandle* handle)
{
   /*
   funkcja okresla wszystkie grupy w danym zdaniu, czy sa twierdzace czy przeczace

   algorytm:
   - sprawdzamy kolejne grupy,
      - sprawdzamy kolejne wyrazy fleksyjne danej grupy,
         - liczymy ile wyrazow negujacych jest w grupie i odpowiednio ja okreslamy,
   */

   int nr1,nr2,neg,poz;
   char dane[100];
   struct GrammarData *gr_data;

   // sprawdzamy kolejne grupy
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      neg=TWIERDZENIE;
      // sprawdzamy kolejne wyrazy fleksyjne danej grupy
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].ile_fleks;nr2++)
      {
         // sprawdzamy, do ktorej grupy nalezy ten wyraz fleksyjny (numer od 1)
         if (get_fleksyjny_group(handle,nr2+1)!=nr1+1) continue;

         // pobieramy fleksje wyrazu
         poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]];
         if (poz!=-1) sprintf(dane,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis,poz+'A'-1);
         else sprintf(dane,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis);

         // sprawdzamy dla kolejnych wyrazow negujacych grupy
         for (gr_data=handle->language.lo1;gr_data!=NULL;gr_data=gr_data->next)
         {
            if (strlen(gr_data->data)>strlen(dane)) continue;
            if (strncmp(gr_data->data,dane,strlen(dane))==0)
            {
               neg= neg==TWIERDZENIE ? PRZECZENIE : TWIERDZENIE;
               break;
            }
         }
      }

      // sprawdzamy rowniez MODYFIKATORY kazdego wyrazu nalezacego do tej grupy
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].words_number;nr2++)
      {
         // sprawdzamy, czy ten wyraz nalezy do badanej grupy
         if (handle->syntax.clause[akt_zd].member[nr2]!=nr1+1) continue;

         // sprawdzamy, czy posiada modyfikator
         if (handle->syntax.clause[akt_zd].wyrazy[nr2]->zrost_poz[handle->syntax.clause[akt_zd].wyrazy[nr2]->zrost_nr]==(int) strlen(handle->syntax.clause[akt_zd].wyrazy[nr2]->orig)) continue;

         // pobieramy fleksje wyrazu modyfikujacego
         poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].wyrazy[nr2]->fleks_buff_nr].poz[handle->syntax.clause[akt_zd].wyrazy[nr2]->fleks_nr];
         if (poz!=-1) sprintf(dane,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].wyrazy[nr2]->fleks_buff_nr].odm[handle->syntax.clause[akt_zd].wyrazy[nr2]->fleks_nr]->opis,poz+'A'-1);
         else sprintf(dane,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].wyrazy[nr2]->fleks_buff_nr].odm[handle->syntax.clause[akt_zd].wyrazy[nr2]->fleks_nr]->opis);

         // sprawdzamy dla kolejnych wyrazow negujacych grupy
         for (gr_data=handle->language.lo1;gr_data!=NULL;gr_data=gr_data->next)
         {
            if (strlen(gr_data->data)>strlen(dane)) continue;
            if (strncmp(gr_data->data,dane,strlen(dane))==0)
            {
               neg= neg==TWIERDZENIE ? PRZECZENIE : TWIERDZENIE;
               break;
            }
         }
      }

      handle->syntax.clause[akt_zd].posneg[nr1]=neg;
   }
}

static int universal_bell(char *member,int *ile,int ile_max)
{
   /*
   - wstepnie kazdy element podzbioru wskazuje na jeden element zbioru,
     (liczba elementow podzbioru jest rowna liczbie elementow zbioru)
   - niech X bedzie numerem elementu zbioru, i przyjmuje kolejno wartosci N,N-1...1
      - jesli numer elementu podzbioru, do ktorego nalezy element zbioru o numerze X jest wiekszy od 1 to:
         - jesli liczba X jest rowna numerowi elementu podzbioru to zmniejszamy o 1 liczbe elementow podzbioru,
         - zmniejszamy o jeden numer elementu podzbioru, do ktorego nalezy element zbioru o numerze X
         - ustalamy numery wskazywanych elementow zbioru kolejnych elementow podzbioru:
            - zaczynajac od wartosci rownej liczbie elementow zbioru zwiekszonej o jeden,
              dla kazdego nastepnego numeru elementu wpisujemy te wartosc powiekszajac ja o 1,
         - zwracamy kolejna mozliwosc,
      - jesli nie to:
         - powtarzamy petle,
   */

   int nr1,nr2,nr3;

   if (member[ile_max-1]>1)
   {
      member[ile_max-1]--;
      *ile=member[ile_max-1];
      for (nr2=ile_max-2;nr2>0 && nr2+1>*ile;nr2--)
         if (member[nr2]>*ile) *ile=member[nr2];

      return 1;
   }

   for (nr1=ile_max-2;nr1>0;nr1--)
   {
      if (member[nr1]>1)
      {
         member[nr1]--;

         nr3=nr1+1;
         member[nr3]=1;
         for (nr2=nr1;nr2+1>member[nr3];nr2--)
            if (member[nr2]>member[nr3]) member[nr3]=member[nr2];

         member[nr3]++;
         for (nr2=nr3+1;nr2<ile_max;nr2++)
            member[nr2]=member[nr2-1]+1;

         *ile=member[ile_max-1];
         for (nr2=*ile-2;nr2>0 && nr2+1>*ile;nr2--)
            if (member[nr2]>*ile) *ile=member[nr2];

         return 1;
      }
   }

   return 0;
}

static int check_opis_dane(struct DeniseHandle *handle,char *opis,char *dane)
{
   /*
   sprawdzamy, czy w opisie znajduja sie podane dane fleksyjne,
   tj. czy dane moga byc scharakteryzowane przez opis
   opis - slowny
   dane - kodowanie znakowe
   funkcja zwraca;
   0 - gdy opisy nie sa zgodne,
   1 - gdy sa zgodne,
   */

//   char nr1,*param,ile_param,temp[5];
   unsigned char nr1, ile_param;
   char *param=NULL,temp[5]; 

   // liczba parametrow w opisie
   ile_param=glo_count_parts(handle,opis,',');

   // rezerwujemy pamiec na opis
   if ((param=malloc(strlen(opis)+1))==NULL) return 0;

   // dane musza byc najmniej tak precyzyjne jak opis
   if (ile_param>strlen(dane))
   {
      free(param);
      return 0;
   }

   // pobieramy kolejne parametry z danych i sprawdzamy, czy sa zawarte w opisie
   for (nr1=0;nr1<ile_param;nr1++)
   {
      // pobieramy parametr z opisu
      glo_get_part(opis,nr1+1,param,',');

      // czy w opisie jest zawarta informacja z dane[nr1]
      sprintf(temp,"/%d-",dane[nr1]-'A'+1);
      if (atoi(param)!=dane[nr1]-'A'+1 && strstr(param,temp)==NULL)
      {
         free(param);
         return 0;
      }
   }

   free(param);
   return 1;
}

static int gra_word_check(struct DeniseHandle* handle,struct Odmiany *odm1,struct Odmiany *odm2)
{
   /*
   funkcja sprawdza, czy dopuszczalny jest zrost wyrazow o fleksji jak podano
   w parametrach odm1 i odm2
   UWAGA! w chwili obecnej nie jest uwzgledniany parametr pozycyjny, gdyz wydaje
   sie on byc w tej sytuacji informacja wielce nadmiarowa, co zweryfikuje przyszlosc

   algorytm:
   - pobieramy informacje o dozwolonych zrostach,
   - sprawdzamy, czy podane parametry fleksji sa zgodne z opisem,
     jesli nie, to sprawdzamy kolejne mozliwosci, jesli tak to OK,
   */

   struct GrammarData *gra_word;
   char temp[1000],part_nr;

   for (gra_word=handle->language.gr1;gra_word!=NULL;gra_word=gra_word->next)
   {
      for (part_nr=1;part_nr<=2;part_nr++)
      {
         // pobieramy opis zrostu z oceny gramatycznej
         if (glo_get_part(gra_word->data,part_nr,temp,'+')==0) break;

         // sprawdzamy zgodnosc opisu z podanymi danymi
         if (check_opis_dane(handle,temp,part_nr==1 ? odm1->opis : odm2->opis)==1)
         {
            if (part_nr==2) return 1;
         }
         else break;
      }
   }

   return 0;
}

static int create_zrosty(struct DeniseHandle* handle)
{
   /*
   funkcja tworzy tablice wszystkich mozliwych pozycji dla zrostow
   */

   struct Fleksja *fleks1,*fleks2,**allfleks1,**allfleks2;
   struct Odmiany *odm1,*odm2;
   int nr1,k1,k2;
   char zrost1[100],zrost2[100];

   for (nr1=0;nr1<handle->syntax.words_number;nr1++)
   {
      // jesli wyraz jest zbyt krotki, to pomijamy
      if ((int) strlen(handle->syntax.words[nr1].orig)<handle->syntaxparams.min_prefix_len)
      {
         handle->syntax.words[nr1].zrost_nr=0;
         handle->syntax.words[nr1].ile_mozliwosci=1;
         handle->syntax.words[nr1].zrost_poz[0]=strlen(handle->syntax.words[nr1].orig);
         continue;
      }

      for (handle->syntax.words[nr1].ile_mozliwosci=0,handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].ile_mozliwosci]=strlen(handle->syntax.words[nr1].orig);
           handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].ile_mozliwosci]>handle->syntaxparams.min_prefix_len-1;
           handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].ile_mozliwosci]--)
      {
         sprintf(zrost1,"%.*s",handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].ile_mozliwosci],handle->syntax.words[nr1].orig);
         sprintf(zrost2,"%s",handle->syntax.words[nr1].orig+handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].ile_mozliwosci]);
//printf("%s=%s+%s\n",handle->syntax.words[nr1].orig,zrost1,zrost2);

         // przeszukujemy baze fleksji (zrost musi istniec w bazie jako wyraz calosciowy)
				 allfleks1=dat_find_word(handle,handle->language.vocabulary,"",zrost1,"",handle->syntaxparams.prefix_check_mode);
         for (k1=0,fleks1=allfleks1[k1];fleks1!=NULL;k1++,fleks1=allfleks1[k1])
         {
            // jesli wyraz jest jednolity, to od razu akceptujemy jesli tylko jest w bazie
            if (strlen(zrost2)==0) {
										free(allfleks1);
										goto accept;
						}

            for (odm1=dat_find_odm(handle,fleks1->odm_head,zrost1,"",handle->syntaxparams.prefix_check_mode);odm1!=NULL;odm1=dat_find_odm(handle,odm1->next,zrost1,"",handle->syntaxparams.prefix_check_mode))
            {
							 allfleks2=dat_find_word(handle,handle->language.vocabulary,"",zrost2,"",handle->syntaxparams.prefix_check_mode);
               if ((fleks2=*allfleks2)!=NULL)
               {
                  for (k2=0;fleks2!=NULL;k2++,fleks2=allfleks2[k2])
                  {
                     for (odm2=dat_find_odm(handle,fleks2->odm_head,zrost2,"",handle->syntaxparams.prefix_check_mode);odm2!=NULL;odm2=dat_find_odm(handle,odm2->next,zrost2,"",handle->syntaxparams.prefix_check_mode))
                     {
                        // ocena gramatyczna zrostu
                        if (gra_word_check(handle,odm1,odm2)==1) {
																free(allfleks1);
																free(allfleks2);
																goto accept;
												}
                     }
                  }
               } else {
											 free(allfleks1);
											 free(allfleks2);
											 goto next;
							 }
							 free(allfleks2);
            }
         }
         // jesli nie odnaleziono wyrazu w bazie, lub gramatyka nie akceptuje takiego zrostu to pomijamy
				 free(allfleks1);
         next: continue;

         accept:
         handle->syntax.words[nr1].ile_mozliwosci++;
         handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].ile_mozliwosci]=handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].ile_mozliwosci-1];
      }

      if (handle->syntax.words[nr1].ile_mozliwosci==0)
      {
			log_unknown_word(handle,handle->syntax.words[nr1].orig);
	      return 0;
      }

      handle->syntax.words[nr1].zrost_nr=0;
   }

   return 1;
}

static int check_zrosty(struct WordData *jedn,int ile)
{
   int nr1;

   for (nr1=0;nr1<ile;nr1++)
   {
      jedn[nr1].zrost_nr++;
      if (jedn[nr1].zrost_nr<jedn[nr1].ile_mozliwosci) return 1;
      jedn[nr1].zrost_nr=0;
   }

   return 0;
}

static int zdania_pojedyncze(struct DeniseHandle* handle)
{
//   static int ilewyr1=-1;
   int nr1,nr2;

   if (handle->syntax.clause_number==1)
   {
      ilewyr1=-1;
      return 0;
   }

   // uwzglednianie rozbicia zdania pierwszego
   if (handle->syntax.clause_number>2 && ilewyr1==-1)
   {
      ilewyr1=handle->syntax.podzial[0].words_number;
      w1=handle->syntax.podzial[2].words_number;
      for (nr1=0;nr1<w1;nr1++)
//     zdanie[0].wyrazy[ilewyr1+nr1]=zdanie[2].wyrazy[nr1];
      handle->syntax.podzial[0].wyrazy[ilewyr1+nr1]=handle->syntax.podzial[2].wyrazy[nr1];
//      memcpy(&zdanie[0].wyrazy[ilewyr1],zdanie[2].wyrazy,handle->syntax.zdania[2].ile_wyrazow);

      handle->syntax.podzial[0].words_number+=handle->syntax.podzial[2].words_number;

      // kopiujemy zdanie czwarte i kolejne o jedno miejsce wczesniej
      for (nr1=3;nr1<handle->syntax.clause_number;nr1++)
      {  w1=handle->syntax.podzial[nr1].words_number;
    for (nr2=0;nr2<w1;nr2++)
       handle->syntax.podzial[nr1-1].wyrazy[nr2]=handle->syntax.podzial[nr1].wyrazy[nr2];
//         memcpy(zdanie[nr1-1].wyrazy,zdanie[nr1].wyrazy,handle->syntax.podzial[nr1].words_number);

         handle->syntax.podzial[nr1-1].words_number=handle->syntax.podzial[nr1].words_number;
      }

      handle->syntax.clause_number--;
      return 1;
   }
   else if (ilewyr1!=-1)
   {
      // kopiujemy zdanie trzecie i kolejne o jedno miejsce DALEJ
      for (nr1=handle->syntax.clause_number-1;nr1>=2;nr1--)
      {  w1=handle->syntax.podzial[nr1].words_number;
    for (nr2=0;nr2<w1;nr2++)
       handle->syntax.podzial[nr1+1].wyrazy[nr2]=handle->syntax.podzial[nr1].wyrazy[nr2];
//         memcpy(zdanie[nr1+1].wyrazy,zdanie[nr1].wyrazy,handle->syntax.podzial[nr1].words_number);

         handle->syntax.podzial[nr1+1].words_number=handle->syntax.podzial[nr1].words_number;
      }

      // kopiujemy "nadmiarowe" wyrazy ze zdania pierwszego do trzeciego
      w1=handle->syntax.podzial[0].words_number;
      for (nr1=ilewyr1;nr1<w1;nr1++)
    handle->syntax.podzial[2].wyrazy[nr1-ilewyr1]=handle->syntax.podzial[0].wyrazy[nr1];

      handle->syntax.podzial[2].words_number=handle->syntax.podzial[0].words_number-ilewyr1;
      handle->syntax.podzial[0].words_number=ilewyr1;
      handle->syntax.clause_number++;
      ilewyr1=-1;
   }

   // idziemy do przedostatniego zdania i zwiekszamy je o 1
   // i dodajemy pierwszy wyraz ze zdania ostatniego
   // handle->syntax.clause_number-2 jest zawsze >=0 (patrz warunek na poczatku funkcji)
   handle->syntax.podzial[handle->syntax.clause_number-2].wyrazy[handle->syntax.podzial[handle->syntax.clause_number-2].words_number++]=handle->syntax.podzial[handle->syntax.clause_number-1].wyrazy[0];

   // idziemy do ostatniego zdania i zmniejszamy o 1
   // i kasujemy pierwszy wyraz
   if (--handle->syntax.podzial[handle->syntax.clause_number-1].words_number>0)
   {  w1=handle->syntax.podzial[handle->syntax.clause_number-1].words_number;
      for (nr1=0;nr1<w1;nr1++)
         handle->syntax.podzial[handle->syntax.clause_number-1].wyrazy[nr1]=handle->syntax.podzial[handle->syntax.clause_number-1].wyrazy[nr1+1];
   }

//   for (;;)
   while(1)
   {
      // jesli pozostalo 0 wyrazow to zmniejszamy liczbe zdan
      if (handle->syntax.podzial[handle->syntax.clause_number-1].words_number==0)
      {
         handle->syntax.clause_number--;
         return 1;
      }
      // jesli pozostalo wiecej niz 1 wyraz
      else if (handle->syntax.podzial[handle->syntax.clause_number-1].words_number>1)
      {
         // to kopiujemy te wartosc zmniejszona o 1 do nastepnego zdania
         handle->syntax.podzial[handle->syntax.clause_number].words_number=handle->syntax.podzial[handle->syntax.clause_number-1].words_number-1;
         handle->syntax.clause_number++;

         // i kopiujemy wyrazy za pierwszym do nastepnego zdania
    w1=handle->syntax.podzial[handle->syntax.clause_number-1].words_number;
    for (nr1=0;nr1<w1;nr1++)
      handle->syntax.podzial[handle->syntax.clause_number-1].wyrazy[nr1]=handle->syntax.podzial[handle->syntax.clause_number-2].wyrazy[nr1+1];
//         memcpy(zdanie[handle->syntax.clause_number].wyrazy,&zdanie[handle->syntax.clause_number-1].wyrazy[1],handle->syntax.zdania[handle->syntax.clause_number].ile_wyrazow);

         // i ustawiamy wartosc 1 na przedostatnim zdaniu
         handle->syntax.podzial[handle->syntax.clause_number-2].words_number=1;
      }
      else return 1;
   }
}

static int struktura_zdan(struct DeniseHandle* handle)
{
   int nr1;
   w1=handle->syntax.clause_number-1;
   for (nr1=0;nr1<w1;nr1++)
   {
      switch(handle->syntax.clause_tree[nr1])
      {
         case NADRZEDNE: handle->syntax.clause_tree[nr1]=WSPOLRZEDNE; return 1;
         case WSPOLRZEDNE:
            // KATALIZATOR: ZALOZENIE: ZDANIE PIERWSZE NIGDY PODRZEDNE
            if (nr1==0 && handle->syntaxparams.first_clause==ON)
            {
               handle->syntax.clause_tree[0]=NADRZEDNE;
               break;
            }
            else
            {
               handle->syntax.clause_tree[nr1]=PODRZEDNE;
               return 1;
            }
         case PODRZEDNE: handle->syntax.clause_tree[nr1]=NADRZEDNE;
      }
   }

   return 0;
}

static int aktywne_rozbiory(struct DeniseHandle* handle)
{
	/*
	zwykly licznik, kazda pozycja oznacza numer (od 0) rozbioru danego zdania
   pojedynczego, i jest liczona do tylu ile jest mozliwosci rozbioru tego zdania

	algorytm:
   - szukamy pierwszego zdania, w ktorym mozna zmienic rozbior na nastepny,
   	- jesli znaleziono, to ustalamy wszystkie wczesniejsze zdania na rozbiory
      	aktywne nr 0, i wychodzimy z return 1
		- jesli nie ma takiego zdania, to return 0,
   */

   int nr1;

   // szukamy pierwszego zdania, w ktorym mozna zmienic rozbior na nastepny,
   for (nr1=0;nr1<handle->syntax.clause_number;nr1++)
	{
   	if (handle->syntax.active[nr1]+1<handle->syntax.ile_accepted[nr1])
      {
   		// jesli znaleziono, to ustalamy wszystkie wczesniejsze zdania na rozbiory
	      //	aktywne nr 0, i wychodzimy z return 1
			handle->syntax.active[nr1]++;
         for (nr1--;nr1>=0;nr1--)
         	handle->syntax.active[nr1]=0;
         return 1;
      }
   }

   return 0;
}

// STRUKTURA WEWNETRZNA POSZCZEGOLNYCH ZDAN
static int droga(struct DeniseHandle* handle,int nr1)
{
   int nr2;

   if (nr1==0) return 1;
   w1=handle->syntax.clause[akt_zd].groups_number;
   for (nr2=1;nr2<w1;nr2++)
      if ((nr1=handle->syntax.clause[akt_zd].parent[nr1-1])==0) return 1;

   return 0;
}

static int droga_funkcyjna(struct DeniseHandle* handle)
{
   /*
   miedzy grupa podrzedna (na dowolnym poziomie) do podmiotu nie moze byc orzeczenia,
   funkcja sprawdza, czy tak jest, jesli nie - zwraca 0,

   praktycznie: jesli jakas grupa nie "przechodzi" przez orzeczenie (funkcja 2)
   w drodze do podmiotu, a znajduje sie ZA orzeczeniem (w stosunku do podmiotu)
   to blad,
   */
   int nr1,par,podm=-1,orzecz=-1;

   // znajdujemy podmiot i orzeczenie
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      if (handle->syntax.clause[akt_zd].function[nr1]==1) podm=nr1;
      else if (handle->syntax.clause[akt_zd].function[nr1]==2) orzecz=nr1;
   }

   if (podm < 0 || orzecz < 0)
	   printf("Brak podmiotu lub orzeczenia (droga_funkcyjna() w grammar1.c)");
 
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      // jesli to podmiot lub orzeczenie to pomijamy
      if (handle->syntax.clause[akt_zd].function[nr1]<=2) continue;

      // sprawdzamy, czy jest to grupa "ryzyka"
      if ((podm<orzecz && nr1<orzecz) || (podm>orzecz && nr1>orzecz)) continue;

      // skoro jest "ryzykowna", to sprawdzamy, czy przechodzi przez orzeczenie
      for (par=handle->syntax.clause[akt_zd].parent[nr1];;)
      {
         // jesli to podmiot to blad!
         if (par==0) return 0;

         // jesli to orzeczenie to spoko ;)
         if (par==orzecz+1) return 1;

         par=handle->syntax.clause[akt_zd].parent[par-1];
      }
   }

   // jesli nie bylo grup ryzyka, to tez spoko
   return 1;
}

int nr0=0;       //globalna zamiast static

static int struktura_grup(struct DeniseHandle* handle)
{
//   static int nr0=0;
   int nr1,nr2,nadrz,nadrz2,nr11,nr21;
   int abc;

   od_nowa:
   w1=handle->syntax.clause[akt_zd].groups_number;w2=w1-1;
   for (nr1=handle->syntax.clause[akt_zd].groups_number-1;nr1>=0;nr1--)
   {
      // jesli to grupa nadrzedna do wszystkich to pomijamy ja
      if (nr1==nr0) continue;

      nr11=nr1+1;

      for (nadrz=handle->syntax.clause[akt_zd].parent[nr1]+1;nadrz<=w1;nadrz++)
      {
         // czy mozemy zwiekszyc numer grupy nadrzednej?
         if (
            // grupa nie moze byc nadrzedna dla samej siebie
            (nadrz==nr11) ||
            // grupa nie moze byc jednoczesnie nadrzedna i podrzedna
            (nadrz<nr11 && handle->syntax.clause[akt_zd].parent[nadrz-1]==nr11)
            )
         // jesli nie mozemy, to
//         {
       continue;
//         }
         // jesli mozemy, to
         else
         {
            handle->syntax.clause[akt_zd].parent[nr1]=nadrz;

            // jesli zmieniana grupa nie byla ostatnia, to zmieniamy kolejne
       if (nr1==w2)
       {
          for (abc=w2;abc>=0;abc--)
        if (droga(handle,handle->syntax.clause[akt_zd].parent[abc])==0) goto od_nowa;

               return 1;
            }

       for (nr2=nr11;nr2<w1;nr2++)
       {
          // jesli to grupa nadrzedna dla wszystkich to pomijamy
          if (nr2==nr0) continue;
          nr21=nr2+1;

          for (nadrz2=1;nadrz2<=w1;nadrz2++)
          {
       if (
           // grupa nie moze byc nadrzedna dla samej siebie
           (nadrz2==nr21) ||
           // grupa nie moze byc jednoczesnie nadrzedna i podrzedna
           (nadrz2<nr21 && handle->syntax.clause[akt_zd].parent[nadrz2-1]==nr21)
           )
//        {
           continue;
//        }
        else
        {
           handle->syntax.clause[akt_zd].parent[nr2]=nadrz2;
                     break;
                  }
               }
            }

       for (abc=w2;abc>=0;abc--)
          if (droga(handle,handle->syntax.clause[akt_zd].parent[abc])==0) goto od_nowa;

            return 1;
         }
      }
   }

   // czy to koniec mozliwosci?
   if (nr0==w2)
   {
      nr0=0;
      return 0;
   }

   // ustawiamy kolejna grupe jako zerowa
   handle->syntax.clause[akt_zd].parent[++nr0]=0;

   // i ustawiamy wszystkie grupy nadrzedne grup pozostalych
   for (nr1=0;nr1<w1;nr1++)
   {
      // jesli to grupa nadrzedna dla wszystkich to pomijamy
      if (nr1==nr0) continue;

      nr11=nr1+1;

      for (nadrz=1;nadrz<=w1;nadrz++)
      {
         if (
            // grupa nie moze byc nadrzedna dla samej siebie
            (nadrz==nr11) ||
            // grupa nie moze byc jednoczesnie nadrzedna i podrzedna
            (nadrz<nr11 && handle->syntax.clause[akt_zd].parent[nadrz-1]==nr11)
            )
//         {
           continue;
//         }
    else
    {
       handle->syntax.clause[akt_zd].parent[nr1]=nadrz;
       break;
    }
      }
   }

   for (abc=w2;abc>=0;abc--)
      if (droga(handle,handle->syntax.clause[akt_zd].parent[abc])==0) goto od_nowa;

   return 1;
}
int fun2=-1;
static int funkcje_grup(struct DeniseHandle* handle)
{
   /*
   grupy przyjmuja funkcje o numerach: 1...ILE_FUNKCJI
   moze byc tylko jedna grupa z funkcja 1 i jedna z funkcja 2,

   algorytm:
   - zwykly licznik z eliminacja blednych ustawien,
   */

   int nr1,podm,orzecz;

   START_HERE: ;
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      if (handle->syntax.clause[akt_zd].function[nr1]<ILE_FUNKCJI)
      {
         handle->syntax.clause[akt_zd].function[nr1]++;
         goto TEST_HERE;
      }
      else handle->syntax.clause[akt_zd].function[nr1]=1;
   }
   // koniec mozliwosci
   return 0;

   TEST_HERE: ;
   // moze byc tylko jedna grupa z funkcja 1 i jedna z funkcja 2,
   for (nr1=0,podm=0,orzecz=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      if (handle->syntax.clause[akt_zd].function[nr1]==1)
      {
         if (podm==1) goto START_HERE;
         podm=1;
      }
      else if (handle->syntax.clause[akt_zd].function[nr1]==2)
      {
         if (orzecz==1) goto START_HERE;
         orzecz=1;
      }
   }
   // MUSI byc PODMIOT i ORZECZENIE
   if (podm==0 || orzecz==0) goto START_HERE;
   return 1;
}

static int priorytet_zrostu(struct DeniseHandle* handle)
{
   /*
   dla kolejnych wyrazow:
   - jesli priorytet ma pierwszy zrost:
      - jesli wyraz posiada drugi zrost, to ustalamy priorytet na drugi, RETURN 1
      - jesli wyraz nie posiada drugiego zrostu, to NASTEPNY WYRAZ,
   - jesli priorytet ma drugi zrost:
      - ustalamy priorytet na pierwszy zrost, i NASTEPNY WYRAZ,
   */

   int nr1;

   for (nr1=0;nr1<handle->syntax.words_number;nr1++)
   {
      // jesli priorytet ma pierwszy zrost
      if (handle->syntax.words[nr1].priority==0)
      {
         // czy wyraz posiada drugi zrost?
         if (handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].zrost_nr]<(int) strlen(handle->syntax.words[nr1].orig))
         {
            handle->syntax.words[nr1].priority=1;
            return 1;
         }
      }
      // jesli priorytet ma drugi zrost
      else
      {
         // ustalamy priorytet na pierwszy zrost, i NASTEPNY WYRAZ,
         handle->syntax.words[nr1].priority=0;
      }
   }

   return 0;
}

static int create_fleksyjne(struct DeniseHandle* handle)
{
   /*
   dla kolejnych wyrazow fleksyjnych (glownych):
   - sprawdzamy, czy fleksje wyrazu zostaly juz znalezione i sa pamietane,
   - jesli nie, to:
      - szukamy wszystkich fleksji wyrazu i zapamietujemy,
   */

   struct Fleksja *fleks,**allfleks;
   struct Odmiany *odm;
   char wyraz[100];
   int nr1,nr2,poz,k1;

   for (nr1=0;nr1<handle->syntax.clause[akt_zd].ile_fleks;nr1++)
   {
      // formalne zapisanie wyrazow i znalezienie pierwszych odmian
      wyraz[0]='\0';
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].words_number;nr2++)
         if (handle->syntax.clause[akt_zd].fleksyjny[nr2]==nr1+1)
         {
            if (wyraz[0]!='\0') strcat(wyraz," ");

            if (handle->syntax.clause[akt_zd].wyrazy[nr2]->priority==0)
                strncat(wyraz,
                handle->syntax.clause[akt_zd].wyrazy[nr2]->orig,
                handle->syntax.clause[akt_zd].wyrazy[nr2]->zrost_poz[handle->syntax.clause[akt_zd].wyrazy[nr2]->zrost_nr]);
            else
               strcat(wyraz,handle->syntax.clause[akt_zd].wyrazy[nr2]->orig+handle->syntax.clause[akt_zd].wyrazy[nr2]->zrost_poz[handle->syntax.clause[akt_zd].wyrazy[nr2]->zrost_nr]);
         }

      // sprawdzamy czy fleksje wyrazu sa juz pamietane
      for (nr2=0;nr2<handle->syntax.buffer_len;nr2++)
      {
         // jesli sa juz pamietane, to
         if (strcmp(wyraz,handle->syntax.voc_buffer[nr2].wyraz)==0 && strlen(wyraz)==strlen(handle->syntax.voc_buffer[nr2].wyraz))
         {
            // jesli sa jakies dane, to podajemy lokalizacje
            if (handle->syntax.voc_buffer[nr2].fleks_ile>0)
            {
               handle->syntax.clause[akt_zd].fleks_buff_nr[nr1]=nr2;
               handle->syntax.clause[akt_zd].fleks_nr[nr1]=0; // na pierwsza mozliwosc
               goto NASTEPNY_WYRAZ;
            }
            // jesli wyrazu nie ma w bazie fleksji, to RETURN 0
            else
            {
               return 0;
            }
         }
      }

      strcpy(handle->syntax.voc_buffer[handle->syntax.buffer_len].wyraz,wyraz);
      handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile=0;

      // jesli nie ma w bazie takiego wyrazu to zapamietujemy to i RETURN 0
			allfleks=dat_find_word(handle,handle->language.vocabulary,"",wyraz,"",0);
      if ((fleks=*allfleks)==NULL)
      {
				 free(allfleks);
         handle->syntax.buffer_len++;
         return 0;
      }

      for (k1=0;fleks!=NULL;k1++,fleks=allfleks[k1])
      {
         for (odm=dat_find_odm(handle,fleks->odm_head,wyraz,"",0);odm!=NULL;odm=dat_find_odm(handle,odm->next,wyraz,"",0))
         {
            for (poz=glo_get_part_position(1,odm->odmiany,wyraz,',');poz!=0;poz=glo_get_part_position(poz+1,odm->odmiany,wyraz,','))
            {
               handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks[handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile]=fleks;
               handle->syntax.voc_buffer[handle->syntax.buffer_len].odm[handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile]=odm;
               handle->syntax.voc_buffer[handle->syntax.buffer_len].poz[handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile]=glo_count_parts(handle,odm->odmiany,',')>1 ? poz : -1;
               handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile++;
            }
         }
      }
			free(allfleks);

      // wskazanie gdzie sa dane o fleksji wyrazu fleksyjnego
      handle->syntax.clause[akt_zd].fleks_buff_nr[nr1]=handle->syntax.buffer_len;
      handle->syntax.clause[akt_zd].fleks_nr[nr1]=0; // na pierwsza mozliwosc
      handle->syntax.buffer_len++;

      NASTEPNY_WYRAZ: ;
   }

   return 1;
}

static int new_fleksja_fleksyjnych(struct DeniseHandle* handle)
{
   /*
   dla kolejnych wyrazow fleksyjnych (glownych):
   - jesli mozna wskazac na kolejna fleksje wyrazu, to wskazujemy i RETURN 1,
   - jesli nie mozna wskazac na kolejna fleksje wyrazu, to:
      - wskazujemy na pierwsza fleksje, i NASTEPNY WYRAZ,
   */

   int nr1;

   for (nr1=0;nr1<handle->syntax.clause[akt_zd].ile_fleks;nr1++)
   {
      // jesli mozna wskazac na kolejna fleksje wyrazu
      if (handle->syntax.clause[akt_zd].fleks_nr[nr1]<handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[nr1]].fleks_ile-1)
      {
         // to wskazujemy i RETURN 1,
         handle->syntax.clause[akt_zd].fleks_nr[nr1]++;
//printf("!%s=%s!\n",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].wyraz,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis);
         return 1;
      }
      // jesli nie mozna wskazac na kolejna fleksje wyrazu, to:
      // wskazujemy na pierwsza fleksje, i NASTEPNY WYRAZ,
      else handle->syntax.clause[akt_zd].fleks_nr[nr1]=0;
//printf("!%s=%s!\n",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].wyraz,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis);
   }

   return 0;
}

static int create_modyfleks(struct DeniseHandle* handle)
{
   /*
   dla kolejnych wyrazow fleksyjnych (modyfikujacych):
   - sprawdzamy, czy fleksje wyrazu zostaly juz znalezione i sa pamietane,
   - jesli nie, to:
      - szukamy wszystkich fleksji wyrazu i zapamietujemy,
   */

   struct Fleksja *fleks,**allfleks;
   struct Odmiany *odm;
   char wyraz[100];
   int nr1,nr2,poz,k1;

   for (nr1=0;nr1<handle->syntax.words_number;nr1++)
   {
      // sprawdzamy, czy jest modyfikator - jesli nie, to pomijamy wyraz
      if (handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].zrost_nr]==(int) strlen(handle->syntax.words[nr1].orig)) continue;

      // formalne zapisanie modyfikatora
      if (handle->syntax.words[nr1].priority==0)
         strcpy(wyraz,handle->syntax.words[nr1].orig+handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].zrost_nr]);
      else
          sprintf(wyraz,"%.*s",handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].zrost_nr],handle->syntax.words[nr1].orig);

      // sprawdzamy czy fleksje wyrazu sa juz pamietane
      for (nr2=0;nr2<handle->syntax.buffer_len;nr2++)
      {
         // jesli sa juz pamietane, to
         if (strcmp(wyraz,handle->syntax.voc_buffer[nr2].wyraz)==0)
         {
            // jesli sa jakies dane, to podajemy lokalizacje
            if (handle->syntax.voc_buffer[nr2].fleks_ile>0)
            {
               handle->syntax.words[nr1].fleks_buff_nr=nr2;
               handle->syntax.words[nr1].fleks_nr=0; // na pierwsza mozliwosc
               goto NASTEPNY_WYRAZ;
            }
            // jesli wyrazu nie ma w bazie fleksji, to RETURN 0
            else
            {
               return 0;
            }
         }
      }

      strcpy(handle->syntax.voc_buffer[handle->syntax.buffer_len].wyraz,wyraz);
      handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile=0;

      // jesli nie ma w bazie takiego wyrazu to zapamietujemy to i RETURN 0
			allfleks=dat_find_word(handle,handle->language.vocabulary,"",wyraz,"",0);
      if ((fleks=*allfleks)==NULL)
      {
				 free(allfleks);
         handle->syntax.buffer_len++;
         return 0;
      }

      for (k1=0;fleks!=NULL;k1++,fleks=allfleks[k1])
      {
         for (odm=dat_find_odm(handle,fleks->odm_head,wyraz,"",0);odm!=NULL;odm=dat_find_odm(handle,odm->next,wyraz,"",0))
         {
            for (poz=glo_get_part_position(1,odm->odmiany,wyraz,',');poz!=0;poz=glo_get_part_position(poz+1,odm->odmiany,wyraz,','))
            {
               handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks[handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile]=fleks;
               handle->syntax.voc_buffer[handle->syntax.buffer_len].odm[handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile]=odm;
               handle->syntax.voc_buffer[handle->syntax.buffer_len].poz[handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile]=glo_count_parts(handle,odm->odmiany,',')>1 ? poz : -1;
               handle->syntax.voc_buffer[handle->syntax.buffer_len].fleks_ile++;
            }
         }
      }
			free(allfleks);
      // wskazanie gdzie sa dane o fleksji wyrazu fleksyjnego
      handle->syntax.words[nr1].fleks_buff_nr=handle->syntax.buffer_len;
      handle->syntax.words[nr1].fleks_nr=0; // na pierwsza mozliwosc
      handle->syntax.buffer_len++;

      NASTEPNY_WYRAZ: ;
   }

   return 1;
}

static int fleksja_modyfikatora(struct DeniseHandle* handle)
{
   /*
   dla kolejnych wyrazow fleksyjnych (modyfikujacych):
   - jesli mozna wskazac na kolejna fleksje wyrazu, to wskazujemy i RETURN 1,
   - jesli nie mozna wskazac na kolejna fleksje wyrazu, to:
      - wskazujemy na pierwsza fleksje, i NASTEPNY WYRAZ,
   */

   int nr1;

   for (nr1=0;nr1<handle->syntax.words_number;nr1++)
   {
      // sprawdzamy, czy jest modyfikator - jesli nie, to pomijamy wyraz
      if (handle->syntax.words[nr1].zrost_poz[handle->syntax.words[nr1].zrost_nr]==(int) strlen(handle->syntax.words[nr1].orig)) continue;

      // jesli mozna wskazac na kolejna fleksje wyrazu
      if (handle->syntax.words[nr1].fleks_nr<handle->syntax.voc_buffer[handle->syntax.words[nr1].fleks_buff_nr].fleks_ile-1)
      {
         // to wskazujemy i RETURN 1,
         handle->syntax.words[nr1].fleks_nr++;
         return 1;
      }
      // jesli nie mozna wskazac na kolejna fleksje wyrazu, to:
      // wskazujemy na pierwsza fleksje, i NASTEPNY WYRAZ,
      else handle->syntax.words[nr1].fleks_nr=0;
   }

   return 0;
}

static void print_grupa(struct DeniseHandle *handle,struct Clause *clause,char *txt,int nr_grupy)
{
   int nr1,check=0;
   char temp[100];

	txt[0]='\0';

   for (nr1=0;nr1<clause->words_number;nr1++)
   {
      if (clause->member[nr1]==nr_grupy)
      {
         if (check==0) check=1;
         else
         {
            sprintf(temp," ");
            strcat(txt,temp);
         }
         sprintf(temp,"%s [%s]",clause->wyrazy[nr1]->orig,handle->syntax.voc_buffer[clause->fleks_buff_nr[clause->fleksyjny[nr1]-1]].fleks[clause->fleks_nr[clause->fleksyjny[nr1]-1]]->podst);
         strcat(txt,temp);
      }
   }
}

static void rysuj_strukture(struct DeniseHandle* handle,struct Clause *clause,int margines,int nr_grupy)
{
   /*
   algorytm:
   - szukamy grupy, dla ktorej nr_grupy jest nadrzedna, i wypisujemy ja na "marginesie"
      - rekurencyjnie
   */

   char *nazwy[]={"podmiot","orzeczenie","przydawka","dopelnienie","okolicznik"};
   char spaces[100];
   char txt[100];
   int nr1;

   memset(spaces,' ',100);
   txt[0]='\0';

   if (nr_grupy==-1)
   {
      for (nr1=0;nr1<clause->groups_number;nr1++)
         if (clause->function[nr1]==1) break; // podmiot ma funkcje 1

      print_grupa(handle,clause,txt,nr1+1);
      DeniseReport(handle,"%s (%s)",txt,nazwy[0]);
      nr_grupy=nr1+1;
      margines=3;
   }

   for (nr1=0;nr1<clause->groups_number;nr1++)
   {
      if (clause->parent[nr1]==nr_grupy)
      {
         print_grupa(handle,clause,txt,nr1+1);
         DeniseReport(handle,"%.*s%s (%s)",margines,spaces,txt,nazwy[clause->function[nr1]-1]);
         rysuj_strukture(handle,clause,margines+3,nr1+1);
      }
   }
}

static void pokaz_rozbior_zdania(struct DeniseHandle* handle,struct Clause *clause)
{
   char *nazwy[]={"podmiot","orzeczenie","przydawka","dopelnienie","okolicznik"};
//   int nr1,nr2;
//   char txt[100];

//   DeniseReport(handle,"jakosc zdania pojedynczego: %d%%",handle->syntax.clause[akt_zd].quality);
//   printf("* zdanie pojedyncze\n");
/*
   printf("wyrazy odseparowane: ");
   for (nr1=0;nr1<clause->words_number;nr1++)
      printf("%s,",clause->wyrazy[nr1]->orig);
   printf("\n");

   printf("wyrazy fleksyjne: ");
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].ile_fleks;nr1++)
   {
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].words_number;nr2++)
         if (handle->syntax.clause[akt_zd].fleksyjny[nr2]==nr1+1) printf(" %s",handle->syntax.clause[akt_zd].wyrazy[nr2]->orig);
      printf(",");
   }
   printf("\n");

   printf("wyrazy calosciowe: ");
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      print_grupa(clause,txt,nr1+1);
      printf("%s,",txt);
   }
   printf("\n");

   printf("funkcje: ");
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
         printf("%s ",nazwy[handle->syntax.clause[akt_zd].function[nr1]-1]);
   printf("\n");
*/
   rysuj_strukture(handle,clause,0,-1);
}

static void print_grupa_zaakceptowana(struct DeniseHandle *handle,struct AcceptedClause *clause,char *txt,int nr_grupy)
{
   int nr1,check=0;
   char temp[100];

	txt[0]='\0';

   for (nr1=0;nr1<clause->words_number;nr1++)
   {
      if (clause->member[nr1]==nr_grupy)
      {
         if (check==0) check=1;
         else
         {
            sprintf(temp," ");
            strcat(txt,temp);
         }
         sprintf(temp,"%s [%s]",clause->wyrazy[nr1]->orig,clause->voc_data[clause->fleksyjny[nr1]-1].fleks->podst);
         strcat(txt,temp);
      }
   }
}

static void rysuj_strukture_zaakceptowana(struct DeniseHandle* handle,struct AcceptedClause *clause,int margines,int nr_grupy)
{
   /*
   algorytm:
   - szukamy grupy, dla ktorej nr_grupy jest nadrzedna, i wypisujemy ja na "marginesie"
      - rekurencyjnie
   */

   char *nazwy[]={"podmiot","orzeczenie","przydawka","dopelnienie","okolicznik"};
   char spaces[100];
   char txt[100];
   int nr1;

   memset(spaces,' ',100);
   txt[0]='\0';

   if (nr_grupy==-1)
   {
      for (nr1=0;nr1<clause->groups_number;nr1++)
         if (clause->function[nr1]==1) break; // podmiot ma funkcje 1

      print_grupa_zaakceptowana(handle,clause,txt,nr1+1);
      DeniseReport(handle,"%s (%s)",txt,nazwy[0]);
      nr_grupy=nr1+1;
      margines=3;
   }

   for (nr1=0;nr1<clause->groups_number;nr1++)
   {
      if (clause->parent[nr1]==nr_grupy)
      {
         print_grupa_zaakceptowana(handle,clause,txt,nr1+1);
         DeniseReport(handle,"%.*s%s (%s) [%d]",margines,spaces,txt,nazwy[clause->function[nr1]-1],clause->parent_word[nr1]);
         rysuj_strukture_zaakceptowana(handle,clause,margines+3,nr1+1);
      }
   }
}

static void pokaz_rozbior_zaakceptowany(struct DeniseHandle* handle,struct AcceptedClause *clause)
{
//   char *nazwy[]={"podmiot","orzeczenie","przydawka","dopelnienie","okolicznik"};
//   int nr1,nr2;
//   char txt[100];

   rysuj_strukture_zaakceptowana(handle,clause,0,-1);
}

static int gra_zdania_pojedyncze(struct DeniseHandle* handle)
{
   /*
   ocena gramatyczna podzialu na zdania pojedyncze

   algorytm:
   - dla kolejnych zdan:
      - sprawdzamy stosunek do zdania nastepnego: wspolrzedny, nadrzedny, podrzedny
         - dokonujemy odpowiedniej kontroli zaleznie od stosunku,

   zdania wspolrzedne:
   - sprawdzamy, czy spojnik na koncu zdania odpowiada laczeniu wspolrzednemu,
   - okreslamy rodzaj polaczenia, i zapamietujemy go (CON_AND,CON_XOR,CON_OR,CON_THEN)
   - eliminujemy ze zdania spojnik,

   zdanie nadrzedne+podrzedne:
   - brak

   zdanie podrzedne+nadrzedne:
   - brak
   */

   int nr1,typ;

   // domyslnie: zdanie pierwsze ma numer nr1, zdanie drugie nr1+1
   for (nr1=0;nr1<handle->syntax.clause_number-1;nr1++)
   {
      // pierwsze i drugie zdanie wspolrzedne
      if (handle->syntax.clause_tree[nr1]==WSPOLRZEDNE)
      {
         // badamy wyraz na koncu zdania
			typ=gra_conjunction_type(handle,handle->syntax.clause[nr1].wyrazy[handle->syntax.clause[nr1].words_number-1]->orig,NULL);

         // jesli wyraz nie jest spojnikiem, to nie mozemy tego zaakceptowac
         if (typ==NO_CON) return 0;

         // jesli wyraz jest spojnikiem, to akceptujemy i kasujemy go ze zdania
         handle->syntax.clause[nr1].words_number--;

         // zapamietujemy operator laczacy zdania
         handle->syntax.logic_tree[nr1]=typ;
      }
      // pierwsze zdanie nadrzedne do drugiego
      else if (handle->syntax.clause_tree[nr1]==NADRZEDNE)
      {
         return 0;
      }
      // pierwsze zdanie podrzedne do drugieg
      else if (handle->syntax.clause_tree[nr1]==PODRZEDNE)
      {
         return 0;
      }
   }

   return 1;
}

static int gra_funkcje_wyrazen(struct DeniseHandle* handle)
{
   /*
   ocena gramatyczna funkcji wyrazen zdania pojedynczego:
   - sprawdzane jest, czy dane wyrazenie moze pelnic wybrana funkcje,

   algorytm:
   - sprawdzamy kolejne grupy - jesli znajduja sie w nich czesci mowy, ktore
     nie moga wystepowac w danej funkcji, to nie akceptujemy wyrazenia,
   - jakosc oblicza sie jako stosunek liczby grup zaakceptowanych do liczby
     wszystkich grup w zdaniu, pomnozony przez 100,
   - jesli otrzymana jakosc jest mniejsza od wymaganej funkcja zwraca 0,
     w przeciwnym razie 1,

   PRZEMYSLEC: sprawdzac grupy, czy moze jednak wyrazy?

   */

   struct GrammarData *gra_data;
   int nr1,nr2,ile_ok=0,quality;

   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      // sprawdzamy kolejne wyrazy grupy
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].words_number;nr2++)
      {
         if (handle->syntax.clause[akt_zd].member[nr2]==nr1+1)
         {
            for (gra_data=handle->language.gr6[handle->syntax.clause[akt_zd].function[nr1]-1];gra_data!=NULL;gra_data=gra_data->next)
            {
               if (strchr(gra_data->data,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis[0])!=NULL)
               {
                  // mozliwy katalizator
                  if (handle->syntaxparams.function_quality==100) return 0;
                  goto NEXT_GRUPA;
               }
            }
         }
      }

      ile_ok++;
      NEXT_GRUPA: ;
   }

   quality=ile_ok*100/max(1,handle->syntax.clause[akt_zd].groups_number);
   if (quality<handle->syntaxparams.function_quality) return 0;

   handle->syntax.clause[akt_zd].quality+=quality;
   handle->syntax.clause[akt_zd].ctrl_numbers++;
//printf("QUALITY 1: %d%%\n",quality);
   return 1;
}

static int get_fleksyjny_group(struct DeniseHandle* handle,int fleks_nr)
{
   // fleks_nr - numer (od 1) wyrazu fleksyjnego

   int nr1;

   for (nr1=0;nr1<handle->syntax.clause[akt_zd].words_number;nr1++)
      if (handle->syntax.clause[akt_zd].fleksyjny[nr1]==fleks_nr)
         return handle->syntax.clause[akt_zd].member[nr1]; // zwracamy numer grupy (liczony od 1)

   DeniseReport(handle,"wystapil blad!");
   return -1; // blad!
}

static void sklejanie_wyrazow(struct DeniseHandle* handle,char *numery,char *posneg,struct GrammarExtData *wzory[100],char (*wyrazy)[100],int ile_wyr,char *sklejone,int nr_grupy)
{
   struct GrammarExtData *gra;
   int poz,nr1,nr2,ile,result;
   char temp1[100],temp2[100];
   char posneg1=TWIERDZENIE;

//   for (nr1=0;nr1<ile_wyr;nr1++) printf("%s+",wyrazy[nr1]); printf("\n");

   // probujemy dopasowac wzor na roznych pozycjach w grupie,
   // tak, zeby umozliwic sklejenie min. 1 wyrazu,
   for (poz=0;poz<ile_wyr;poz++)
   {
      // pobieramy kolejne wzory z bazy danych gramatycznych,
      for (gra=wzory[wyrazy[poz][0]-'A'];gra!=NULL;gra=gra->next)
      {
         // liczba wyrazow musi byc wieksza rowna liczbie wyrazow we wzorze
         if (ile_wyr-poz<gra->parts_number) continue;

         // poza przypadkiem, kiedy zaden nie jest sklejony
         if (memchr(sklejone,1,ile_wyr)!=NULL)
         {
            // w sklejanej partii musi byc najmniej jeden sklejony wyraz
            if (memchr(sklejone+poz,1,gra->parts_number)==NULL) continue;
         }

         // w sklejanej partii musi byc najmniej jeden wyraz do sklejenia
         if (memchr(sklejone+poz,0,gra->parts_number)==NULL) continue;

         // jesli podano zakazane czesci mowy, to sprawdzamy, czy wystepuja
         if (gra->zakaz_miedzy!=NULL)
         {
            // pobieramy kolejne wyrazy wystepujace MIEDZY laczonymi w wyrazeniu
            for (nr1=numery[0]+1;nr1<numery[ile_wyr-1];nr1++)
            {
               // pomijamy wyrazy sklejane aktualnie
               if (ile_wyr==3) if (numery[1]==nr1) continue;
               if (ile_wyr==4) if (numery[1]==nr1 || numery[2]==nr1) continue;

               // kontrolujemy czesc mowy
//               if (strchr(gra->zakaz_miedzy,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis[0])!=NULL) goto NEXT_WZOR;
					nr2=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]];
					if (nr2!=-1) sprintf(temp1,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis,nr2+'A'-1);
					else sprintf(temp1,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis);

					ile=glo_count_parts(handle,gra->zakaz_miedzy,';');
					for (nr2=0;nr2<ile;nr2++)
               {
						glo_get_part(gra->zakaz_miedzy,nr2+1,temp2,';');
			         if (gra_wyrazenie_check(handle,&posneg1,temp2,temp1)==1) goto NEXT_WZOR;
               }
            }
         }

         switch (gra->parts_number)
         {
            case 2: result=gra_wyrazenie_check(handle,posneg,gra->data,wyrazy[poz],wyrazy[poz+1]); break;
            case 3: result=gra_wyrazenie_check(handle,posneg,gra->data,wyrazy[poz],wyrazy[poz+1],wyrazy[poz+2]); break;
            case 4: result=gra_wyrazenie_check(handle,posneg,gra->data,wyrazy[poz],wyrazy[poz+1],wyrazy[poz+2],wyrazy[poz+3]); break;
            default: printf("blad 1!\n"); return;
         }

//         printf("?: %s=",gra->data);
//         for (nr1=poz;nr1<ile_wyr;nr1++) printf("%s+",wyrazy[nr1]); printf("\n");

         // jesli pasuje
         if (result==1)
         {
            // to oznaczamy konkretne wyrazy jako sklejone
            memset(sklejone+poz,1,gra->parts_number);

				// generujemy fleksje wynikowa dla grupy sklejonych wyrazow
				if (gra->fleksja_wynikowa!=NULL)
				{
					strcpy(handle->syntax.clause[akt_zd].group_fleks[nr_grupy],gra->fleksja_wynikowa);
					for (nr1=0;nr1<(int) strlen(gra->fleksja_wynikowa);nr1++)
					{
						if (handle->syntax.clause[akt_zd].group_fleks[nr_grupy][nr1]=='?')
							handle->syntax.clause[akt_zd].group_fleks[nr_grupy][nr1]=wyrazy[poz][nr1];
					}
//printf("fleksja wynikowa: %s\n",gra->fleksja_wynikowa);
				}

//sprintf(handle->syntax.clause[akt_zd].group_fleks[nr_grupy],"ABBA");

//            printf("?: %s=",gra->data);
//            for (nr1=poz;nr1<ile_wyr;nr1++) printf("%s+",wyrazy[nr1]); printf(" ");
//            printf("OK\n");

/*				temp1[0]='\0';
	         for (nr1=poz;nr1<ile_wyr;nr1++)
            {
            	sprintf(temp2,"%s+",wyrazy[nr1]);
               strcat(temp1,temp2);
            }
				if (strlen(temp1)>0) temp1[strlen(temp1)-1]='\0';
            DeniseReport(handle,"dopuszczone polaczenie: %s",temp1);
*/         }
			else
         {
/*				temp1[0]='\0';
	         for (nr1=poz;nr1<ile_wyr;nr1++)
            {
            	sprintf(temp2,"%s+",wyrazy[nr1]);
               strcat(temp1,temp2);
            }
				if (strlen(temp1)>0) temp1[strlen(temp1)-1]='\0';
            DeniseReport(handle,"niedopuszczone polaczenie: %s",temp1);
*/         }

         NEXT_WZOR:;
      }
   }
}

static int gra_budowa_wyrazenia(struct DeniseHandle* handle)
{
   /*
   ocena gramatyczna budowy wyrazenia (grupy),

   etapy:
   1) sklejanie wyrazow niesamodzielnych z samodzielnymi,
   2) sklejanie szeregow wyrazow samodzielnych tej samej czesci mowy,
   3) sklejanie wyrazow samodzielnych roznych czesci mowy,

   ostateczna ocena [%]: stosunek liczby wyrazow sklejonych do calkowitej
   liczby wyrazow w grupie pomnozony przez 100,
   jesli ocena jest nizsza niz wymagana, zwracamy RETURN 0

   ogolny algorytm sklejania (2 i wiecej wyrazow):
   - dla kolejnych grup:
      - budujemy pelna strukture fleksyjna wszystkich wyrazow w grupie:
         - pobieramy kolejne wyrazy fleksyjne, ktore naleza do tej grupy,
         - dopisujemy ich fleksje do tablicy,
         - dodatkowo zapamietujemy numer wyrazu w tablicy fleksyjnej,
           w tablicy reprezentujacej rzeczywista kolejnosc wyrazow w zdaniu,
      - sklejanie w 3 etapach j. w., ogolny opis ponizej:

   ogolny algorytm sklejania dla kazdego etapu:

   - jesli grupa sklada sie z jednego wyrazu fleksyjnego, to sprawdzamy, czy
     wyraz jest samodzielny - jesli nie, to blad,
   - jesli grupa sklada sie z wiecej niz jednego wyrazu fleksyjnego, to:
      - pobieramy kolejne wzory z bazy danych gramatycznych,
      - probujemy dopasowac wzor na roznych pozycjach w grupie, tak, zeby umozliwic
        sklejenie min. 1 wyrazu,
         - jesli pasuje, to oznaczamy konkretne wyrazy jako sklejone,

   UWAGA! dodano opcje kontroli zakazanych czesci mowy, tj. ktore nie moga
   wystepowac w zdaniu POMIEDZY laczonymi wyrazami w wyrazeniu
   */

   int nr1,nr2,poz,ile_wyrazow,quality;
   char wyrazy[100][100],sklejone[100],posneg[10];
   char numery[100]; // zawiera numery-1 (od 0) wyrazow fleksyjnych (zachowuje kolejnosc w zdaniu)

   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
		// zerujemy dane fleksyjne grup
		handle->syntax.clause[akt_zd].group_fleks[nr1][0]='\0';

      ile_wyrazow=0;
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].ile_fleks;nr2++)
      {
         // sprawdzamy, do ktorej grupy nalezy ten wyraz fleksyjny (numer od 1)
         if (get_fleksyjny_group(handle,nr2+1)!=nr1+1) continue;

         numery[ile_wyrazow]=nr2;

         poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]];
         if (poz!=-1) sprintf(wyrazy[ile_wyrazow],"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis,poz+'A'-1);
         else sprintf(wyrazy[ile_wyrazow],"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis);
         ile_wyrazow++;
      }

      // jesli grupa sklada sie z jednego wyrazu fleksyjnego,
      if (ile_wyrazow==1)
      {
         // to sprawdzamy, czy wyraz jest samodzielny - jesli nie, to blad,
         if (strchr(handle->language.gr2,wyrazy[0][0])==NULL) return 0;
         continue;
      }
      // jesli grupa sklada sie z wiecej niz jednego wyrazu fleksyjnego, to:
      else if (ile_wyrazow>1)
      {
         memset(sklejone,0,ile_wyrazow);
         memset(posneg,handle->syntax.clause[akt_zd].posneg[nr1],ile_wyrazow);

         // gramatyczne sklejanie wyrazow fleksyjnych w grupie:
         // 1) sklejanie wyrazow niesamodzielnych z samodzielnymi,
			if (handle->language.gr3!=NULL)
			{
				sklejanie_wyrazow(handle,numery,posneg,handle->language.gr3,wyrazy,ile_wyrazow,sklejone,nr1);
   	      if (memchr(sklejone,0,ile_wyrazow)==NULL) continue;
			}

         // 2) sklejanie szeregow wyrazow samodzielnych tej samej czesci mowy,
			if (handle->language.gr4!=NULL)
			{
				sklejanie_wyrazow(handle,numery,posneg,handle->language.gr4,wyrazy,ile_wyrazow,sklejone,nr1);
   	      if (memchr(sklejone,0,ile_wyrazow)==NULL) continue;
			}

         // 3) sklejanie wyrazow samodzielnych roznych czesci mowy,
			if (handle->language.gr5!=NULL)
			{
				sklejanie_wyrazow(handle,numery,posneg,handle->language.gr5,wyrazy,ile_wyrazow,sklejone,nr1);
      	   if (memchr(sklejone,0,ile_wyrazow)==NULL) continue;
			}

         // ocena gramatyczna budowy wyrazenia
         for (poz=0,nr2=0;nr2<ile_wyrazow;nr2++)
            if (sklejone[nr2]==1) poz++;

         quality=poz*100/ile_wyrazow;
         if (quality<handle->syntaxparams.phrase_quality) return 0;
         handle->syntax.clause[akt_zd].quality+=quality;
         handle->syntax.clause[akt_zd].ctrl_numbers++;
//printf("QUALITY 2: %d%%\n",quality);
      }
   }
   return 1;
}

static int gra_wymagana_czesc_mowy(struct DeniseHandle* handle,char *dane,int grupa)
{
   int nr1,nr2,nr3,ile,poz;
   char temp1[200],temp2[200];
   char posneg=TWIERDZENIE;

   // sprawdzamy kolejne wymagane czesci mowy
   for (nr1=0;nr1<(int) strlen(dane);nr1++)
   {
      // sprawdzamy kolejne wyrazy grupy
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].words_number;nr2++)
      {
         if (handle->syntax.clause[akt_zd].member[nr2]!=grupa) continue;

         // jesli znaleziono czesc mowy to nastepna wymagana czesc mowy
//         if (dane[nr1]==handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis[0]) goto NEXT_CZESC_MOWY;

			// pobieramy dane fleksyjne wyrazu
	      poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]];
	      if (poz!=-1) sprintf(temp1,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis,poz+'A'-1);
	      else sprintf(temp1,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis);

			ile=glo_count_parts(handle,dane,';');
	      for (nr3=0;nr3<ile;nr3++)
	      {
	       	glo_get_part(dane,nr3+1,temp2,';');
	         if (gra_wyrazenie_check(handle,&posneg,temp2,temp1)==1) goto NEXT_CZESC_MOWY;
	      }
      }
      // jesli nie znaleziono to return 0
      return 0;

      NEXT_CZESC_MOWY: ;
   }
   // jesli znaleziono wszystkie
   return 1;
}

static int gra_zabroniona_czesc_mowy(struct DeniseHandle* handle,char *dane,int grupa)
{
   int nr1,nr2,poz,ile;
   char temp1[200],temp2[200];
   char posneg=TWIERDZENIE;

   // sprawdzamy kolejne wyrazy grupy
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].words_number;nr1++)
   {
      if (handle->syntax.clause[akt_zd].member[nr1]!=grupa) continue;

      // jesli to zabroniona czesc mowy to wychodzimy z REturn 0
//      if (strchr(dane,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis[0])!=NULL) return 0;

		// pobieramy dane fleksyjne wyrazu
      poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]];
      if (poz!=-1) sprintf(temp1,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis,poz+'A'-1);
      else sprintf(temp1,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis);

//DeniseMessage(handle,"%s=%s, zabr: %s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->odmiany,temp1,dane);

      ile=glo_count_parts(handle,dane,';');
      for (nr2=0;nr2<ile;nr2++)
      {
         glo_get_part(dane,nr2+1,temp2,';');
         if (gra_wyrazenie_check(handle,&posneg,temp2,temp1)==1)
		 {
//			 DeniseMessage(handle,"WRONG");
			 return 0;
		 }
      }
   }
//DeniseMessage(handle,"ACCEPTED");
   // jesli nie ma zabronionych czesci mowy to okay tokay
   return 1;
}

static int gra_zabronione_funkcje_miedzy(struct DeniseHandle* handle,char *dane,int grupa1,int grupa2)
{
   int pos1,pos2,nr1;
   char temp[200];

   pos1=min(grupa1,grupa2)-1;
   pos2=max(grupa1,grupa2)-1;

   // sprawdzamy kolejne grupy wystepujace miedzy podanymi
   for (nr1=pos1+1;nr1<pos2;nr1++)
   {
      sprintf(temp,"%d",handle->syntax.clause[akt_zd].function[nr1]);
      // sprawdzamy, czy grupa pelni zakazana funkcje w zdaniu - jesli tak to return 0
      if (strchr(dane,temp[0])!=NULL) return 0;
   }

   return 1;
}

static int gra_zabronione_fleksje_miedzy(struct DeniseHandle* handle,char *dane,int grupa1,int grupa2)
{
	/*
	- szukamy pierwszego wyrazu odseparowanego, ktory nalezy do jednej z podanych dwoch grup
   - szukamy ostatniego,
	- sprawdzamy fleksje wszystkich wyrazow fleksyjnych, do ktorych naleza wyrazy odseparowane
     lezace miedzy znalezionymi wyrazami odseprawowanymi, pomijajac oczywiscie te
     wyrazy, ktore naleza do podanych,
   */
   int pos1,pos2,poz,nr1,nr2;
   char temp[200],fleks[200];
   char posneg=TWIERDZENIE;

	// szukamy pierwszego wyrazu odseparowanego, ktory nalezy do jednego z podanych dwoch fleksyjnych
	for (pos1=0;pos1<handle->syntax.clause[akt_zd].words_number;pos1++)
//   	if (handle->syntax.clause[akt_zd].fleksyjny[pos1]==fleks1 || handle->syntax.clause[akt_zd].fleksyjny[pos1]==fleks2) break;
   	if (handle->syntax.clause[akt_zd].member[pos1]==grupa1 || handle->syntax.clause[akt_zd].member[pos1]==grupa2) break;

   // szukamy ostatniego,
	for (pos2=handle->syntax.clause[akt_zd].words_number-1;pos2>=0;pos2--)
//   	if (handle->syntax.clause[akt_zd].fleksyjny[pos2]==fleks1 || handle->syntax.clause[akt_zd].fleksyjny[pos2]==fleks2) break;
   	if (handle->syntax.clause[akt_zd].member[pos2]==grupa1 || handle->syntax.clause[akt_zd].member[pos2]==grupa2) break;

//DeniseReport(handle,"POS1: %d, POS2: %d (wyrazy: %d,%d)",pos1+1,pos2+1,fleks1,fleks2);

	// sprawdzamy fleksje wszystkich wyrazow fleksyjnych, do ktorych naleza wyrazy odseparowane
   // lezace miedzy znalezionymi wyrazami odseprawowanymi, pomijajac oczywiscie te
   // wyrazy, ktore naleza do podanych,
   for (nr1=pos1+1;nr1<pos2;nr1++)
   {
//   	if (handle->syntax.clause[akt_zd].fleksyjny[nr1]==fleks1 || handle->syntax.clause[akt_zd].fleksyjny[nr1]==fleks2) continue;
   	if (handle->syntax.clause[akt_zd].member[nr1]==grupa1 || handle->syntax.clause[akt_zd].member[nr1]==grupa2) continue;

		// pobieramy dane fleksyjne wyrazu
      poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]];
      if (poz!=-1) sprintf(fleks,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis,poz+'A'-1);
      else sprintf(fleks,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr1]-1]]->opis);

//DeniseReport(handle,"nr1: %d, fleks: %s",nr1+1,fleks);
		// pobieramy kolejne opisy zabronionych czesci mowy
		poz=glo_count_parts(handle,dane,';');
      for (nr2=0;nr2<poz;nr2++)
      {
       	glo_get_part(dane,nr2+1,temp,';');
			// jesli pobrany wyraz jest z typu zabronionych, to zwracamy 0
//DeniseReport(handle,"temp: %s, fleks: %s",temp,fleks);
         if (gra_wyrazenie_check(handle,&posneg,temp,fleks)==1)
         {
//DeniseReport(handle,"del");
         	return 0;
         }
      }
   }

   return 1;
}

static int gra_struktura(struct DeniseHandle* handle)
{
   /*
   ocena gramatyczna struktury grup w zdaniu pojedynczym,

   algorytm oceny:
   START:
   - dla wszystkich grup podrzednych:
      - pobieramy kolejne wzory z bazy oceny gramatycznej
         - pobieramy kolejne wyrazy fleksyjne grupy nadrzednej
            - pobieramy kolejne wyrazy fleksyjne grupy podrzednej
               - jesli dopuszczalny jest taki zwiazek, to na START;

   ostateczna ocena: [%]
   - stosunek liczby poprawnych zwiazkow do liczby wszystkich zwiazkow (liczba
     rowna liczbie grup pomniejszonej o 1), pomnozony przez 100,
   */

   int nr1,nr2,nr3,ile_ok=0,poz,quality;
   struct GrammarFuncData *gra;
   char nadrz[100],podrz[100],temp[10],posneg[10];

//   DeniseReport(handle,"***");

   // dla wszystkich grup podrzednych
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      if (handle->syntax.clause[akt_zd].parent[nr1]==0) continue;

      // pobieramy fleksje kolejnych wyrazow fleksyjnych grupy podrzednej
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].ile_fleks;nr2++)
      {
         // sprawdzamy, do ktorej grupy nalezy ten wyraz fleksyjny (numer od 1)
         if (get_fleksyjny_group(handle,nr2+1)!=nr1+1) continue;

         // nr2 - numer (w tablicy, od 0) wyrazu fleksyjnego z grupy podrzednej,
         poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]];
         if (poz!=-1) sprintf(podrz,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis,poz+'A'-1);
         else sprintf(podrz,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]]->opis);

         // pobieramy fleksje kolejnych wyrazow fleksyjnych grupy nadrzednej
			// nr3=-1 oznacza pobranie fleksji GRUPY a nie wyrazu
         for (nr3=-1;nr3<handle->syntax.clause[akt_zd].ile_fleks;nr3++)
         {
				if (nr3==-1)
				{
					strcpy(nadrz,handle->syntax.clause[akt_zd].group_fleks[handle->syntax.clause[akt_zd].parent[nr1]-1]);
					// jesli nie ma opisu fleksjyjnego dla calej grupy, to dalej
					if (nadrz[0]=='\0') continue;
				}
				else
				{
	            // sprawdzamy, do ktorej grupy nalezy ten wyraz fleksyjny (numer od 1)
   	         if (get_fleksyjny_group(handle,nr3+1)!=handle->syntax.clause[akt_zd].parent[nr1]) continue;

		         // nr3 - numer (w tablicy, od 0) wyrazu fleksyjnego z grupy nadrzednej,
	            poz=handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr3]-1]].poz[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr3]-1]];
   	         if (poz!=-1) sprintf(nadrz,"%s%c",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr3]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr3]-1]]->opis,poz+'A'-1);
      	      else sprintf(nadrz,"%s",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr3]-1]].odm[handle->syntax.clause[akt_zd].fleks_nr[handle->syntax.clause[akt_zd].fleksyjny[nr3]-1]]->opis);
				}

				// numer wyrazu nadrzednego (0 - nadrzedna cala grupa!)
				handle->syntax.clause[akt_zd].parent_word[nr1]=nr3+1;

            // pobieramy kolejne wzory z bazy oceny gramatycznej
            for (gra=handle->language.gr7[nadrz[0]-'A'];gra!=NULL;gra=gra->next)
            {
               // nr1 - grupa podrzedna (nr1+1 <- numer grupy), parent[nr1] - nadrzedna

//               DeniseReport(handle,"wyrazy: %s=%s\n",handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr3]-1]].wyraz,handle->syntax.voc_buffer[handle->syntax.clause[akt_zd].fleks_buff_nr[handle->syntax.clause[akt_zd].fleksyjny[nr2]-1]].wyraz);
//               DeniseReport(handle,"%s: %s=%s\n",gra->data,nadrz,podrz);

               // sprawdzamy, czy spelniona jest wymagana kolejnosc w zdaniu
               if (gra->kolejnosc!=0)
                  if ((gra->kolejnosc==1 && nr1<handle->syntax.clause[akt_zd].parent[nr1]-1) ||
                      (gra->kolejnosc==2 && nr1>handle->syntax.clause[akt_zd].parent[nr1]-1)) continue;

               // sprawdzamy czy zwiazek dopuszcza zalozone ad hoc funkcje w zdaniu
               if (gra->func!=NULL)
               {
                  sprintf(temp,"%d%d",handle->syntax.clause[akt_zd].function[handle->syntax.clause[akt_zd].parent[nr1]-1],handle->syntax.clause[akt_zd].function[nr1]);
                  // jesli nie dopuszcza takich funkcji to pomijamy
                  if (strstr(gra->func,temp)==NULL) continue;
               }

               // sprawdzamy, czy sa wymagane czesci mowy w grupie podrzednej
               if (gra->memb_podrz!=NULL) if (gra_wymagana_czesc_mowy(handle,gra->memb_podrz,nr1+1)==0) continue;

               // sprawdzamy, czy sa wymagane czesci mowy w grupie nadrzednej
               if (gra->memb_nadrz!=NULL) if (gra_wymagana_czesc_mowy(handle,gra->memb_nadrz,handle->syntax.clause[akt_zd].parent[nr1])==0) continue;

               // sprawdzamy, czy nie ma zabronionych czesci mowy w grupie podrzednej
	           if (gra->zakaz_podrz!=NULL) if (gra_zabroniona_czesc_mowy(handle,gra->zakaz_podrz,nr1+1)==0) continue;
	
               // sprawdzamy, czy nie ma zabronionych czesci mowy w grupie nadrzednej
               if (gra->zakaz_nadrz!=NULL) if (gra_zabroniona_czesc_mowy(handle,gra->zakaz_nadrz,handle->syntax.clause[akt_zd].parent[nr1])==0) continue;

               // sprawdzamy, czy nie ma zabronionych czesci zdania miedzy grupami
               if (gra->zakaz_miedzy_fun!=NULL) if (gra_zabronione_funkcje_miedzy(handle,gra->zakaz_miedzy_fun,nr1+1,handle->syntax.clause[akt_zd].parent[nr1])==0) continue;

               // sprawdzamy, czy nie ma zabronionych czesci mowy miedzy wyrazami (grupami)
					// nr2,nr3 - numery (od 0) wyrazow fleksyjnych: nadrz,podrz
//					if (nr3!=-1)
//					{
//	               if (gra->zakaz_miedzy_fle!=NULL) if (gra_zabronione_fleksje_miedzy(handle,gra->zakaz_miedzy_fle,nr2+1,nr3+1)==0) continue;
//               }

               // sprawdzamy, czy nie ma zabronionych czesci mowy miedzy wyrazami (grupami)
               if (gra->zakaz_miedzy_fle!=NULL) if (gra_zabronione_fleksje_miedzy(handle,gra->zakaz_miedzy_fle,nr1+1,handle->syntax.clause[akt_zd].parent[nr1])==0) continue;

               // jesli dopuszczalny jest taki zwiazek, to kontrola nastepnej grupy
               posneg[0]=handle->syntax.clause[akt_zd].posneg[handle->syntax.clause[akt_zd].parent[nr1]-1];
               posneg[1]=handle->syntax.clause[akt_zd].posneg[nr1];
               if (gra_wyrazenie_check(handle,posneg,gra->data,nadrz,podrz)==1)
               {
					ile_ok++;
//               	DeniseReport(handle,"ocena pozytywna: %s=%s+%s",gra->data,nadrz,podrz);
                  goto NEXT_GROUP;
               }
               else
               {
//               	DeniseReport(handle,"negatywna: %s+%s=%s",nadrz,podrz,gra->data);
               }
            }
         }
      }

      // szybki katalizator
      if (handle->syntaxparams.structure_quality==100)
      {
      	return 0;
      }

      NEXT_GROUP: ;
   }

//   printf("ocena: %d/%d=%d%%\n",ile_ok,handle->syntax.clause[akt_zd].groups_number-1,ile_ok*100/(handle->syntax.clause[akt_zd].groups_number-1));
   quality=ile_ok*100/(max(1,handle->syntax.clause[akt_zd].groups_number-1));
   if (quality<handle->syntaxparams.structure_quality) return 0;

   handle->syntax.clause[akt_zd].quality+=ile_ok*100/(max(1,handle->syntax.clause[akt_zd].groups_number-1));
   handle->syntax.clause[akt_zd].ctrl_numbers++;
//DeniseReport(handle,"QUALITY 3: %d%%\n",ile_ok*100/(handle->syntax.clause[akt_zd].groups_number-1));

   return 1;
}

static void gra_ocen_zdanie(struct DeniseHandle* handle)
{
   /*
   OCENA GRAMATYCZNA ZDANIA POJEDYNCZEGO

   Etap 1:
   - szyk grup powinien byc mozliwie najbardziej zwarty,
     tj. aby grupy podrzedne byly najblizej nadrzednych,
     ocena jakosci: odleglosc obu grup od siebie, (pomijamy podmiot)
     jakosc 100% - gdy grupy stoja bezposrednio obok siebie,
   Etap 2:
   - szyk wyrazow w grupie powinien byc mozliwie najbardziej zwarty,
     tj. aby wyrazy byly polozone w zdaniu najblizej siebie,
     ocena jakosci j.w.
   Etap 3:
   - najwiecej powinno byc odpowiednio: przydawek, dopelnien i okolicznikow
     ocena jakosci: przydawki*3, dopelnienia*2, okoliczniki*1,
     dzielone przez sume (przydawki+dopelnienia+okoliczniki)*3
     i przemnozone przez 100%
   */

   int nr1,nr2,poz;
   int quality1,quality2,quality3;

   // ETAP 1
   quality1=0;
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
      // podmiot pomijamy
      if (handle->syntax.clause[akt_zd].function[nr1]!=1) quality1+=abs(nr1-handle->syntax.clause[akt_zd].parent[nr1]+1);
   quality1=(handle->syntax.clause[akt_zd].groups_number-1)*100/max(1,quality1);

// szymon pije piwo

   // ETAP 2
   quality2=0;
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      poz=-1;
      for (nr2=0;nr2<handle->syntax.clause[akt_zd].words_number;nr2++)
      {
         // pomijamy wyrazy z innych grup
         if (handle->syntax.clause[akt_zd].member[nr2]!=nr1+1) continue;

         if (poz==-1)
         {
            poz=nr2;
            quality2++;
         }
         else
         {
            quality2+=abs(poz-nr2);
            poz=nr2;
         }
      }
   }
   quality2=handle->syntax.clause[akt_zd].words_number*100/max(1,quality2);

   // ETAP 3
   quality3=0;
   nr2=0;
   for (nr1=0;nr1<handle->syntax.clause[akt_zd].groups_number;nr1++)
   {
      if (handle->syntax.clause[akt_zd].function[nr1]==3) {quality3+=3;nr2++;}
      else if (handle->syntax.clause[akt_zd].function[nr1]==4) {quality3+=2;nr2++;}
      else if (handle->syntax.clause[akt_zd].function[nr1]==5) {quality3+=1;nr2++;}
   }
   if (nr2==0) quality3=100;
   else quality3=quality3*100/(nr2*3);

   // jakosc oceny jest rowna sredniej arytmetycznej ocen z wszystkich etapow
   handle->syntax.clause[akt_zd].quality+=(quality1+quality2+quality3)/3;
   handle->syntax.clause[akt_zd].ctrl_numbers++;

//   printf("jakosc rozbioru: %d%%,%d%%,%d%% == %d%%\n",quality1,quality2,quality3,(quality1+quality2+quality3)/3);
//printf("QUALITY 4: %d%%\n",(quality1+quality2+quality3)/3);
}
